; DesktopIconGadget - Include

EnableExplicit

Enumeration
	
EndEnumeration

Procedure DesktopIconGadget_BindGadgetEvent(Gadget, Callback, EventType)
	
	! var selector = $("#g_" + Gadget);
	
	If EventType = #PB_All
		
		EventType = #PB_EventType_LeftDoubleClick |
		            #PB_EventType_LeftClick |
		            #PB_EventType_RightClick |
		            #PB_EventType_LeftButtonUp | 
		            #PB_EventType_LeftButtonDown |
		            #PB_EventType_RightButtonUp |
		            #PB_EventType_RightButtonDown
		
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftDoubleClick)) selector.data("onLeftDoubleClick", Callback);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", Callback);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightClick)) selector.data("onRightClick", Callback);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftButtonUp)) selector.data("onLeftButtonUp", Callback);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftButtonDown)) selector.data("onLeftButtonDown", Callback);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightButtonUp)) selector.data("onRightButtonUp", Callback);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightButtonDown)) selector.data("onRightButtonDown", Callback);
	
EndProcedure
RegisterUserGadgetProcedure("DesktopIconGadget", "BindGadgetEvent", @DesktopIconGadget_BindGadgetEvent())

Procedure DesktopIconGadget_UnbindGadgetEvent(Gadget, Callback, EventType)
	
	! var selector = $("#g_" + Gadget);
	
	If EventType = #PB_All
		
		EventType = #PB_EventType_LeftDoubleClick |
		            #PB_EventType_LeftClick |
		            #PB_EventType_RightClick |
		            #PB_EventType_LeftButtonUp | 
		            #PB_EventType_LeftButtonDown |
		            #PB_EventType_RightButtonUp |
		            #PB_EventType_RightButtonDown
		
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftDoubleClick)) selector.data("onLeftDoubleClick", null);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", null);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightClick)) selector.data("onRightClick", null);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftButtonUp)) selector.data("onLeftButtonUp", null);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftButtonDown)) selector.data("onLeftButtonDown", null);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightButtonUp)) selector.data("onRightButtonUp", null);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightButtonDown)) selector.data("onRightButtonDown", null);
	
EndProcedure
RegisterUserGadgetProcedure("DesktopIconGadget", "UnbindGadgetEvent", @DesktopIconGadget_UnbindGadgetEvent())

Procedure DesktopIconGadget_SetGadgetText(Gadget, Text)
	! var selector = $("#g_" + Gadget);
	! selector.find("div").text(Text);
EndProcedure
RegisterUserGadgetProcedure("DesktopIconGadget", "SetGadgetText", @DesktopIconGadget_SetGadgetText())

Procedure DesktopIconGadget_GetGadgetText(Gadget)
	! var selector = $("#g_" + Gadget);
	! return selector.find("div").text();
EndProcedure
RegisterUserGadgetProcedure("DesktopIconGadget", "GetGadgetText", @DesktopIconGadget_GetGadgetText())

Procedure DesktopIconGadget_SetGadgetColor(Gadget, ColorType, Color)
	
	! var selector = $("#g_" + Gadget);
	
	Select ColorType
		Case #PB_Gadget_BackColor
			! selector.css("background-color", Color);
		Case #PB_Gadget_FrontColor
			! selector.find("div").css("color", Color);
	EndSelect
	
EndProcedure
RegisterUserGadgetProcedure("DesktopIconGadget", "SetGadgetColor", @DesktopIconGadget_SetGadgetColor())


Procedure DesktopIconGadget(Gadget, x, y, Width, Height, Text.s, Flags = 0, ImageID = -1)
	
	! Gadget = cCommon.SetGadgetAndStuff(Gadget);

	! var selector = $("<div style='text-align:center;vertical-align:middle'><img /><div /></div>");

	! selector.attr("id", "g_" + Gadget);
	
	! selector.find("div").text(Text);
	
	! if (ImageID != -1) {
	! 	if (typeof ImageID == "string") {
	!   	selector.find("img").attr("src", ImageID);
	! 	} else {
	!   	selector.find("img").attr("src", $("#i_" + ImageID).attr("src"));
	! 	}
	! }
	
	! cCommon.CurrentContainer.append(selector);

	! cCommon.SetGadgetPosition(selector, x, y, Width, Height);
	
	!	selector.data("GadgetType", "DesktopIconGadget");
	
	! selector.bind("click", function (event) {
	! 	var cb = selector.data("onLeftClick");
	! 	if (typeof cb === "function") {
	! 		if (event.which === 1) {
	! 			cEvent.eventGadget = Gadget;
	! 			cEvent.eventType = cConstants.PB_EventType_LeftClick;
	! 			cb();
	! 		}
	! 	}
	! });
	
	! selector.bind("dblclick", function (event) {
	! 	var cb = selector.data("onLeftDoubleClick");
	! 	if (typeof cb === "function") {
	! 		if (event.which === 1) {
	! 			cEvent.eventGadget = Gadget;
	! 			cEvent.eventType = cConstants.PB_EventType_LeftDoubleClick;
	! 			cb();
	! 		}
	! 	}
	! });
	
	! selector.mouseup(function() {
	!		var cb, eventtype;
	!		if (event.which === 1) { // left
	!			cb = selector.data("onLeftButtonUp");
	!			eventtype = cConstants.PB_EventType_LeftButtonUp;
	!		} else if (event.which === 3) { // right
	!			cb = selector.data("onRightButtonUp");
	!			eventtype = cConstants.PB_EventType_RightButtonUp;
	!   }
	!		if (typeof cb === "function") {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = eventtype;
	!			cb();
	!		}
	! });
	
	! selector.mousedown(function() {
	!		var cb, eventtype;
	!		if (event.which === 1) { // left
	!			cb = selector.data("onLeftButtonDown");
	!			eventtype = cConstants.PB_EventType_LeftButtonDown;
	!		} else if (event.which === 3) { // right
	!			cb = selector.data("onRightButtonDown");
	!			eventtype = cConstants.PB_EventType_RightButtonDown;
	!   }
	!		if (typeof cb === "function") {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = eventtype;
	!			cb();
	!		}
	! });
	
	! selector.bind("contextmenu", function (event) {
	! 	var cb = selector.data("onRightClick");
	! 	if (typeof cb === "function") {
	!   	event.preventDefault();
	! 		cEvent.eventGadget = Gadget;
	! 		cEvent.eventType = cConstants.PB_EventType_RightClick;
	! 		cb();
	! 	}
	! });	
	
	! var offset = parseInt(selector.find("div").css("height"));
	! selector.css("height", Height + offset + 3);
	
	SetGadgetCursor(Gadget, #PB_Cursor_Hand)	
	
	! return Gadget;	
	
EndProcedure
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 3
; Folding = B+
; EnableXP