﻿; GoogleMap-Include

Enumeration
	
	; GadgetAttributes (Set/GetGadgetAttribute()):
	
	#GoogleMapType = 1
	#GoogleMapTypeRoadmap = 2
	#GoogleMapTypeSatellite = 3
	#GoogleMapTypeHybrid = 4
	#GoogleMapTypeTerrain = 5
	#GoogleMapZoom = 6
	#GoogleMapBounds = 7
	#GoogleMapCenter = 8
	
	#GoogleMapUseMarkerClusterer = 9
	#GoogleMapMarkerClustererGridSize = 10
	#GoogleMapMarkerClustererMaxZoom = 11
	
	#GoogleMapUseKeyDragZoom = 12
	#GoogleMapKeyDragZoomNoZoom = 13
	
	; ItemAttributes (Set/GetGadgetItemAttribute()):
	
	#GoogleMapMarkerPosition = 1
	#GoogleMapMarkerDraggable = 2
	#GoogleMapPolylineColor = 3
	#GoogleMapPolylineOpacity = 4
	#GoogleMapPolylineWeight = 5
	#GoogleMapPolylineVisible = 6
	
	; ---
	
	#GoogleMapInfoWindow = 1
	#GoogleMapInfoWindowAutoOpen = 2
	
	#PB_GoogleMap_Border = 1
	
	; GoogleMap-Events
	
	#PB_EventType_GoogleMap_BoundsChanged = 1
	#PB_EventType_GoogleMap_CenterChanged = 2
	#PB_EventType_GoogleMap_Click = 4
	#PB_EventType_GoogleMap_DblClick = 8
	#PB_EventType_GoogleMap_Drag = 16
	#PB_EventType_GoogleMap_DragEnd = 32
	#PB_EventType_GoogleMap_DragStart = 64
	#PB_EventType_GoogleMap_HeadingChanged = 128
	#PB_EventType_GoogleMap_Idle = 256
	#PB_EventType_GoogleMap_MapTypeIdChanged = 512
	#PB_EventType_GoogleMap_MouseMove = 1024
	#PB_EventType_GoogleMap_MouseOut = 2048
	#PB_EventType_GoogleMap_MouseOver = 4096
	#PB_EventType_GoogleMap_ProjectionChanged = 8192
	#PB_EventType_GoogleMap_Resize = 16384
	#PB_EventType_GoogleMap_RightClick = 32768
	#PB_EventType_GoogleMap_TilesLoaded = 65536
	#PB_EventType_GoogleMap_TiltChanged = 131072
	#PB_EventType_GoogleMap_ZoomChanged = 262144
	
	; GoogleMapMarker-Events
	
	#PB_EventType_GoogleMapMarker_AnimationChanged = 1
	#PB_EventType_GoogleMapMarker_Click = 2
	#PB_EventType_GoogleMapMarker_ClickableChanged = 4
	#PB_EventType_GoogleMapMarker_CursorChanged = 8
	#PB_EventType_GoogleMapMarker_DblClick = 16
	#PB_EventType_GoogleMapMarker_Drag = 32
	#PB_EventType_GoogleMapMarker_DragEnd = 64
	#PB_EventType_GoogleMapMarker_DraggableChanged = 128
	#PB_EventType_GoogleMapMarker_DragStart = 256
	#PB_EventType_GoogleMapMarker_FlatChanged = 512
	#PB_EventType_GoogleMapMarker_IconChanged = 1024
	#PB_EventType_GoogleMapMarker_MouseDown = 2048
	#PB_EventType_GoogleMapMarker_MouseOut = 4096
	#PB_EventType_GoogleMapMarker_MouseOver = 8192
	#PB_EventType_GoogleMapMarker_MouseUp = 16384
	#PB_EventType_GoogleMapMarker_PositionChanged = 32768
	#PB_EventType_GoogleMapMarker_RightClick = 65536
	#PB_EventType_GoogleMapMarker_ShapeChanged = 131072
	#PB_EventType_GoogleMapMarker_TitleChanged = 262144
	#PB_EventType_GoogleMapMarker_VisibleChanged = 524288
	#PB_EventType_GoogleMapMarker_ZIndexChanged = 1048576	
	
EndEnumeration

Procedure GoogleMapGadget_ResizeGadget(Gadget, x, y, Width, Height)
	
	! var selector = $("#g_" + Gadget);
	!	if (x !== cConstants.PB_Ignore) selector.css("left", x);
	!	if (y !== cConstants.PB_Ignore) selector.css("top", y);
	!	if (Width !== cConstants.PB_Ignore) selector.css("width", Width);	
	!	if (Height !== cConstants.PB_Ignore) selector.css("height", Height);	
	
	!	var myMap = selector.data("googlemap");
	!	google.maps.event.trigger(myMap, 'resize');
	
EndProcedure
RegisterUserGadgetProcedure("GoogleMapGadget", "ResizeGadget", @GoogleMapGadget_ResizeGadget())

Procedure GoogleMapGadget_AddGadgetItem(Gadget, Position, Text.s, ImageID, Flags) 
	
	!	var selector = $("#g_" + Gadget);
	!	var myMap = selector.data("googlemap");
	!	var myMarkerArray = selector.data("markerarray");
	!	var myMarker = new google.maps.Marker({
	!		map: myMap
	!	});
	
	Protected myLat = ValF(StringField(Text, 1, ","))
	Protected myLng = ValF(StringField(Text, 2, ","))
	
	If myLat <> 0 And myLng <> 0 
		
		! // http://www.frontendfan.com/multiple-markers-with-the-exact-same-location/
		
		! var latlng = new google.maps.LatLng(myLat, myLng)
		
		! //final position for marker, could be updated if another marker already exists in same position
		! var finalLatLng = latlng;
		
		! if (selector.data("usemarkerclusterer") === true) {
		!		//check to see if any of the existing markers match the latlng of the new marker
		!		if (myMarkerArray.length != 0) {
		!			for (i=0; i < myMarkerArray.length; i++) {
		!				var existingMarker = myMarkerArray[i];
		!				var pos = existingMarker.getPosition();
		!				//if a marker already exists in the same position as this marker
		!				if (latlng.equals(pos)) {
		!					//update the position of the coincident marker by applying a small multipler to its coordinates
		!					// feel free to tweak an offset however you want.
		!					// (Math.random() -.5) / 1500 is about 100m, 
		!					// (Math.random() -.5) / 750 ~ 50m
		!					// (Math.random() -.5) / 3000 ~ 200m		
		!					var newLat = latlng.lat() + (Math.random() -.5) / 750;
		!					var newLng = latlng.lng() + (Math.random() -.5) / 750;
		!					finalLatLng = new google.maps.LatLng(newLat,newLng);
		!				}
		!			}
		!		}
		! }
		
		! myMarker.setPosition(finalLatLng);
		
	Else
		
		! GoogleMapsGeocoder(Text, myMarker);
		
	EndIf
	
	If ImageID <> (-1)
		
		! var src = $("#i_" + ImageID).attr("src");
		! var width = parseInt($("#i_" + ImageID).css("width"));
		! var height = parseInt($("#i_" + ImageID).css("height"));
		! var icon;
		! if (width > 0 && height > 0) {
		! 	icon = {
		!			url: src, 
		!			scaledSize: new google.maps.Size(width, height), 
		! 	};
		! } else {
		! 	icon = {
		!			url: src
		! 	};
		! }
		
		! myMarker.setIcon(icon);
		
	EndIf	
	
	If Position = (-1)
		! Position = myMarkerArray.length;
	EndIf
	
	!	myMarkerArray.splice(Position, 0, myMarker);
	!	selector.data("markerarray", myMarkerArray)
	
	!	if (selector.data("usemarkerclusterer") === true) {
	!		var markerClusterer = selector.data("markerclusterer");
	!		markerClusterer.addMarker(myMarker);
	!	}
	
EndProcedure
RegisterUserGadgetProcedure("GoogleMapGadget", "AddGadgetItem", @GoogleMapGadget_AddGadgetItem())

Procedure GoogleMapGadget_RemoveGadgetItem(Gadget, Position)
	
	Protected selector
	Protected myMap
	Protected myMarkerArray
	Protected myMarker
	
	!	selector = $("#g_" + Gadget);
	
	If selector	
		
		!	myMap = selector.data("googlemap");
		
		If myMap
			
			!	myMarkerArray = selector.data("markerarray");
			
			If myMarkerArray
				
				!	myMarker = myMarkerArray[Position];
				
				If myMarker
					
					!	myMarker.setMap(null);
					!	myMarkerArray.splice(Position, 1);
					!	selector.data("markerarray", myMarkerArray);
					
					!	if (selector.data("usemarkerclusterer") === true) {
					!		var markerClusterer = selector.data("markerclusterer");
					!		markerClusterer.clearMarkers();
					!		markerClusterer.addMarkers(myMarkerArray);
					!		markerClusterer.repaint();
					!	}	
					
				EndIf
			EndIf
		EndIf
	EndIf
			
EndProcedure
RegisterUserGadgetProcedure("GoogleMapGadget", "RemoveGadgetItem", @GoogleMapGadget_RemoveGadgetItem())

Procedure GoogleMapGadget_ClearGadgetItems(Gadget)
	!	var selector = $("#g_" + Gadget);
	!	var myMarkerArray = selector.data("markerarray");
	!	for (var i = 0; i < myMarkerArray.length; i++) { myMarkerArray[i].setMap(null); }
	!	selector.data("markerarray", []);
	!	if (selector.data("usemarkerclusterer") === true) {
	!		var markerClusterer = selector.data("markerclusterer");
	! 	markerClusterer.clearMarkers();
	! }
EndProcedure
RegisterUserGadgetProcedure("GoogleMapGadget", "ClearGadgetItems", @GoogleMapGadget_ClearGadgetItems())

Procedure GoogleMapGadget_CountGadgetItems(Gadget)
	!	var selector = $("#g_" + Gadget);
	! var myMarkerArray = selector.data("markerarray");
	! return myMarkerArray.length;
EndProcedure
RegisterUserGadgetProcedure("GoogleMapGadget", "CountGadgetItems", @GoogleMapGadget_CountGadgetItems())

Procedure GoogleMapGadget_GetGadgetAttribute(Gadget, Attribute)
	
	!	var selector = $("#g_" + Gadget);
	!	var myMap = selector.data("googlemap");
	
	Select Attribute
		Case #GoogleMapType
			! return myMap.getMapTypeId();
		Case #GoogleMapZoom
			! return myMap.getZoom();
		Default
			ProcedureReturn #False
	EndSelect
	
EndProcedure
RegisterUserGadgetProcedure("GoogleMapGadget", "GetGadgetAttribute", @GoogleMapGadget_GetGadgetAttribute())

Procedure GoogleMapGadget_SetGadgetAttribute(Gadget, Attribute, Value)
	
	Protected selector
	Protected myMap
	Protected myMarker
	Protected myPosition
	Protected myDragZoomObject
	
	!	selector = $("#g_" + Gadget);
	!	myMap = selector.data("googlemap");
	
	!	var myMarkerArray = selector.data("markerarray");
	
	Select Attribute
			
		Case #GoogleMapType
			
			Select Value
					
				Case #GoogleMapTypeHybrid
					! myMap.setMapTypeId(google.maps.MapTypeId.HYBRID);
					
				Case #GoogleMapTypeRoadmap
					! myMap.setMapTypeId(google.maps.MapTypeId.ROADMAP);
					
				Case #GoogleMapTypeSatellite:
					! myMap.setMapTypeId(google.maps.MapTypeId.SATELLITE);
					
				Case #GoogleMapTypeTerrain
					! myMap.setMapTypeId(google.maps.MapTypeId.TERRAIN);
					
			EndSelect
			
		Case #GoogleMapZoom
			
			! myMap.setZoom(Value);
			
		Case #GoogleMapCenter
			
			!	try {
			!   if (typeof Value === 'string') {
			! 		myMap.setCenter(new google.maps.LatLng(Value.split(',')[0],Value.split(',')[1]));
			!   } else {
			!			if (Value < 0) Value = 0;
			!			if (Value > myMarkerArray.length - 1) Value = myMarkerArray.length - 1;
			!			myMarker = myMarkerArray[Value];
			
			If myMarker
				! myPosition = myMarker.getPosition();
				If myPosition
					! myMap.setCenter(myPosition);
				Else
					Debug("GoogleMapCenter failed")
				EndIf
			Else
				Debug("GoogleMapCenter failed")
			EndIf
			
			!		}
			!	}
			!	catch (ex) {
			!		cDebugger.Debug(ex);
			!	}
			
		Case #GoogleMapBounds
			
			!	try {
			!		var myBounds = new google.maps.LatLngBounds();
			!		for (var i = 0; i < myMarkerArray.length; i++) {
			!			myBounds.extend(myMarkerArray[i].getPosition());
			!		}
			!		myMap.fitBounds(myBounds);
			!	} catch (ex) {
			!		cDebugger.Debug(ex);
			!	}
			
		Case #GoogleMapMarkerClustererGridSize
			
			! if (selector.data("usemarkerclusterer") === true) {
			!		var markerClusterer = selector.data("markerclusterer");
			! 	markerClusterer.setGridSize(Value);
			! 	markerClusterer.repaint();
			! }
			
		Case #GoogleMapMarkerClustererMaxZoom 
			
			! if (selector.data("usemarkerclusterer") === true) {
			! 	var markerClusterer = selector.data("markerclusterer");
			! 	markerClusterer.setMaxZoom(Value);
			! 	markerClusterer.repaint();
			! }
			
		Case #GoogleMapUseMarkerClusterer
			
			! var markerClusterer = selector.data("markerclusterer");
			
			Select Value
					
				Case 0, #False
					
					! markerClusterer.clearMarkers();
					! for (var i = 0; i < myMarkerArray.length; i++) { myMarkerArray[i].setOptions({map: myMap, visible:true}); }        					
					! markerClusterer.repaint();
					
					!	selector.data("usemarkerclusterer", false);
					
				Case 1, #True
					
					! markerClusterer.clearMarkers();
					! markerClusterer.addMarkers(myMarkerArray);
					! markerClusterer.repaint();
					
					!	selector.data("usemarkerclusterer", true);
					
			EndSelect
			
		Case #GoogleMapKeyDragZoomNoZoom
			
			! myDragZoomObject = myMap.getDragZoomObject();
			
			If myDragZoomObject
				
				Select Value
					Case 0, #False
						! myDragZoomObject.setNoZoom(false);
					Case 1, #True
						! myDragZoomObject.setNoZoom(true);
				EndSelect
				
			EndIf
			
		Case #GoogleMapUseKeyDragZoom
			
			Select Value
					
				Case 0, #False
					
					! myMap.disableKeyDragZoom();
					
				Case 1, #True
					
					! myMap.enableKeyDragZoom({
					!		boxStyle: {
					!			border: "1px dashed black",
					!			backgroundColor: "transparent",
					!			opacity: 1.0
					!		},
					!		veilStyle: {
					!			webkitUserSelect: "none",
					!			backgroundColor: "gray",
					!			opacity: 0.2,
					!			cursor: "crosshair"
					!		}	
					! });
					
			EndSelect					
			
		Default
			
			Debug("SetGadgetAttributeGoogleMap(): Unknown Attribute");
			
	EndSelect	
	
EndProcedure
RegisterUserGadgetProcedure("GoogleMapGadget", "SetGadgetAttribute", @GoogleMapGadget_SetGadgetAttribute())

Procedure GoogleMapGadget_SetGadgetItemAttribute(Gadget, Item, Attribute, Value, Column)
	
	!	var selector = $("#g_" + Gadget);
	!	var myMarkerArray = selector.data("markerarray");
	!	var myPolylineArray = selector.data("polylinearray");
	
	Select Attribute
			
		Case #GoogleMapMarkerPosition
			
			Protected myLat = ValF(StringField(Str(Value), 1, ","))
			Protected myLng = ValF(StringField(Str(Value), 2, ","))				
			
			!	var myMarker = myMarkerArray[Item];
			! myMarker.setPosition(new google.maps.LatLng(myLat, myLng));
			
		Case #GoogleMapMarkerDraggable
			
			!	var myMarker = myMarkerArray[Item];
			! myMarker.setDraggable(Value);
			
		Case #GoogleMapPolylineColor
			
			! var myPloyline = myPolylineArray[Item]
			! myPloyline.setOptions({strokeColor: Value});
			
		Case #GoogleMapPolylineOpacity
			
			! var myPloyline = myPolylineArray[Item]
			! myPloyline.setOptions({strokeOpacity: Value});
			
		Case #GoogleMapPolylineWeight
			
			! var myPloyline = myPolylineArray[Item]
			! myPloyline.setOptions({strokeWeight: Value});
			
		Case #GoogleMapPolylineVisible
			
			! if (Value==1) Value = true;
			! if (Value==0) Value = false;
			
			! var myPloyline = myPolylineArray[Item]
			! myPloyline.setOptions({visible: Value});
			
		Default
			
			Debug("SetGadgetItemAttributeGoogleMap(): Unknown Attribute");
			
	EndSelect
	
EndProcedure	
RegisterUserGadgetProcedure("GoogleMapGadget", "SetGadgetItemAttribute", @GoogleMapGadget_SetGadgetItemAttribute())

Procedure GoogleMapGadget_GetGadgetItemAttribute(Gadget, Item, Attribute, Column)
	
	Protected myMarker
	
	!	var selector = $("#g_" + Gadget);
	!	var myMarkerArray = selector.data("markerarray");
	!	myMarker = myMarkerArray[Item];
	
	If myMarker
		
		Select Attribute
				
			Case #GoogleMapMarkerPosition
				
				! return myMarker.getPosition().lat() + "," + myMarker.getPosition().lng();
				
			Case #GoogleMapMarkerDraggable
				
				! return myMarker.getDraggable();
				
			Default
				
				Debug("GetGadgetItemAttributeGoogleMap(): Unknown Attribute");
				
		EndSelect
		
	Else
		Debug("GetGadgetItemAttributeGoogleMap(): marker " + Str(Item) + " not found");
	EndIf
	
EndProcedure	
RegisterUserGadgetProcedure("GoogleMapGadget", "GetGadgetItemAttribute", @GoogleMapGadget_GetGadgetItemAttribute())

Procedure GoogleMapGadget_SetGadgetItemImage(Gadget, Item, ImageID)
	
	Protected myMarker
	
	!	var selector = $("#g_" + Gadget);
	!	var myMarkerArray = selector.data("markerarray");
	!	myMarker = myMarkerArray[Item];
	
	If myMarker
		
		! var src = $("#i_" + ImageID).attr("src");
		! var width = parseInt($("#i_" + ImageID).css("width"));
		! var height = parseInt($("#i_" + ImageID).css("height"));
		
		! var icon = {
		!		url: src, 
		!		scaledSize: new google.maps.Size(width, height), 
		! };		
		
		! myMarker.setIcon(icon);
		
	Else
		Debug("GoogleMapGadgetSetGadgetItemImage(): marker " + Str(Item) + " not found");
	EndIf
	
EndProcedure
RegisterUserGadgetProcedure("GoogleMapGadget", "SetGadgetItemImage", @GoogleMapGadget_SetGadgetItemImage())	

Procedure GoogleMapGadget_SetGadgetItemText(Gadget, Item, Text, Column)
	
	Protected myMarker
	
	!	var selector = $("#g_" + Gadget);
	!	var myMap = selector.data("googlemap");
	!	var myMarkerArray = selector.data("markerarray");
	
	!	myMarker = myMarkerArray[Item];
	
	If myMarker
		
		!	if (cCommon.CheckFlag(Column, GoogleMapInfoWindow)) {
		
		!		var myInfoWindow = new google.maps.InfoWindow({
		!			content: Text,
		!			maxWidth: 100
		!		});
		
		!		google.maps.event.addListener(myMarker, 'click', function () {
		!			myInfoWindow.open(myMap, myMarker);
		!		});
		
		!		if (cCommon.CheckFlag(Column, GoogleMapInfoWindowAutoOpen)) {
		!			myInfoWindow.open(myMap, myMarker);
		!		}
		
		!	} else {
		!		myMarker.setTitle(Text);
		!	}
		
	Else
		Debug("GoogleMapGadgetSetGadgetItemText(): marker " + Str(Item) + " not found");
	EndIf
	
EndProcedure
RegisterUserGadgetProcedure("GoogleMapGadget", "SetGadgetItemText", @GoogleMapGadget_SetGadgetItemText())

Procedure GoogleMapGadget_BindGadgetEvent(Gadget, Callback, EventType)
	
	If EventType = #PB_All
		
		EventType =	#PB_EventType_GoogleMap_BoundsChanged |
		           	#PB_EventType_GoogleMap_CenterChanged |
		           	#PB_EventType_GoogleMap_Click |
		           	#PB_EventType_GoogleMap_DblClick |
		           	#PB_EventType_GoogleMap_Drag |
		           	#PB_EventType_GoogleMap_DragEnd |
		           	#PB_EventType_GoogleMap_DragStart |
		           	#PB_EventType_GoogleMap_HeadingChanged |
		           	#PB_EventType_GoogleMap_Idle |
		           	#PB_EventType_GoogleMap_MapTypeIdChanged |
		           	#PB_EventType_GoogleMap_MouseMove |
		           	#PB_EventType_GoogleMap_MouseOut |
		           	#PB_EventType_GoogleMap_MouseOver |
		           	#PB_EventType_GoogleMap_ProjectionChanged |
		           	#PB_EventType_GoogleMap_Resize |
		           	#PB_EventType_GoogleMap_RightClick |
		           	#PB_EventType_GoogleMap_TilesLoaded |
		           	#PB_EventType_GoogleMap_TiltChanged |
		           	#PB_EventType_GoogleMap_ZoomChanged
		
	EndIf
	
	! var selector = $("#g_" + Gadget);
	! var myMap = selector.data("googlemap");
	
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_BoundsChanged)) {
	!		google.maps.event.addListener(myMap, "bounds_changed", function () {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_BoundsChanged;
	!			Callback();
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_CenterChanged)) {
	!		google.maps.event.addListener(myMap, "center_changed", function () {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_CenterChanged;
	!			Callback();
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_Click)) {
	!		google.maps.event.addListener(myMap, "click", function (event) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_Click;
	!			Callback(event.latLng.lat(), event.latLng.lng());
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_DblClick)) {
	!		google.maps.event.addListener(myMap, "dblclick", function (event) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_DblClick;
	!			Callback(event.latLng.lat(), event.latLng.lng());
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_Drag)) {
	!		google.maps.event.addListener(myMap, "drag", function () {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_Drag;
	!			Callback();
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_DragEnd)) {
	!		google.maps.event.addListener(myMap, "dragend", function () {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_DragEnd;
	!			Callback();
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_DragStart)) {
	!		google.maps.event.addListener(myMap, "dragstart", function () {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_DragStart;
	!			Callback();
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_HeadingChanged)) {
	!		google.maps.event.addListener(myMap, "heading_changed", function () {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_HeadingChanged;
	!			Callback();
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_Idle)) {
	!		google.maps.event.addListener(myMap, "idle", function () {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_Idle;
	!			Callback();
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_MapTypeIdChanged)) {
	!		google.maps.event.addListener(myMap, "maptypeid_changed", function () {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_MapTypeIdChanged;
	!			Callback();
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_MouseMove)) {
	!		google.maps.event.addListener(myMap, "mousemove", function (event) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_MouseMove;
	!			Callback(event.latLng.lat(), event.latLng.lng());
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_MouseOut)) {
	!		google.maps.event.addListener(myMap, "mouseout", function (event) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_MouseOut;
	!			Callback(event.latLng.lat(), event.latLng.lng());
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_MouseOver)) {
	!		google.maps.event.addListener(myMap, "mouseover", function (event) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_MouseOver;
	!			Callback(event.latLng.lat(), event.latLng.lng());
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_ProjectionChanged)) {
	!		google.maps.event.addListener(myMap, "projection_changed", function () {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_ProjectionChanged;
	!			Callback();
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_Resize)) {
	!		google.maps.event.addListener(myMap, "resize", function () {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_Resize;
	!			Callback();
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_RightClick)) {
	!		google.maps.event.addListener(myMap, "rightclick", function (event) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_RightClick;
	!			Callback(event.latLng.lat(), event.latLng.lng());
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_TilesLoaded)) {
	!		google.maps.event.addListener(myMap, "tilesloaded", function () {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_TilesLoaded;
	!			Callback();
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_TiltChanged)) {
	!		google.maps.event.addListener(myMap, "tilt_changed", function () {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_TiltChanged;
	!			Callback();
	!		});
	!	}
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_ZoomChanged)) {
	!		google.maps.event.addListener(myMap, "zoom_changed", function () {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_GoogleMap_ZoomChanged;
	!			Callback();
	!		});
	!	}

EndProcedure
RegisterUserGadgetProcedure("GoogleMapGadget", "BindGadgetEvent", @GoogleMapGadget_BindGadgetEvent())

Procedure GoogleMapGadget_UnbindGadgetEvent(Gadget, Callback, EventType)
	
	If EventType = #PB_All
		
		EventType =	#PB_EventType_GoogleMap_BoundsChanged |
		           	#PB_EventType_GoogleMap_CenterChanged |
		           	#PB_EventType_GoogleMap_Click |
		           	#PB_EventType_GoogleMap_DblClick |
		           	#PB_EventType_GoogleMap_Drag |
		           	#PB_EventType_GoogleMap_DragEnd |
		           	#PB_EventType_GoogleMap_DragStart |
		           	#PB_EventType_GoogleMap_HeadingChanged |
		           	#PB_EventType_GoogleMap_Idle |
		           	#PB_EventType_GoogleMap_MapTypeIdChanged |
		           	#PB_EventType_GoogleMap_MouseMove |
		           	#PB_EventType_GoogleMap_MouseOut |
		           	#PB_EventType_GoogleMap_MouseOver |
		           	#PB_EventType_GoogleMap_ProjectionChanged |
		           	#PB_EventType_GoogleMap_Resize |
		           	#PB_EventType_GoogleMap_RightClick |
		           	#PB_EventType_GoogleMap_TilesLoaded |
		           	#PB_EventType_GoogleMap_TiltChanged |
		           	#PB_EventType_GoogleMap_ZoomChanged
		
	EndIf
	
	! var selector = $("#g_" + Gadget);
	! var myMap = selector.data("googlemap");
	
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_BoundsChanged))     google.maps.event.clearListeners(myMap, "bounds_changed");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_CenterChanged))     google.maps.event.clearListeners(myMap, "center_changed");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_Click))             google.maps.event.clearListeners(myMap, "click");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_DblClick))          google.maps.event.clearListeners(myMap, "dblclick");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_Drag))              google.maps.event.clearListeners(myMap, "drag");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_DragEnd))           google.maps.event.clearListeners(myMap, "dragend");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_DragStart))         google.maps.event.clearListeners(myMap, "dragstart");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_HeadingChanged))    google.maps.event.clearListeners(myMap, "heading_changed");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_Idle))              google.maps.event.clearListeners(myMap, "idle");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_MapTypeIdChanged))  google.maps.event.clearListeners(myMap, "maptypeid_changed");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_MouseMove))         google.maps.event.clearListeners(myMap, "mousemove");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_MouseOut))          google.maps.event.clearListeners(myMap, "mouseout");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_MouseOver))         google.maps.event.clearListeners(myMap, "mouseover");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_ProjectionChanged)) google.maps.event.clearListeners(myMap, "projection_changed");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_Resize))            google.maps.event.clearListeners(myMap, "resize");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_RightClick))        google.maps.event.clearListeners(myMap, "rightclick");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_TilesLoaded))       google.maps.event.clearListeners(myMap, "tilesloaded");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_TiltChanged))       google.maps.event.clearListeners(myMap, "tilt_changed");
	!	if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMap_ZoomChanged))       google.maps.event.clearListeners(myMap, "zoom_changed");
	
EndProcedure
RegisterUserGadgetProcedure("GoogleMapGadget", "UnbindGadgetEvent", @GoogleMapGadget_UnbindGadgetEvent())

Procedure GoogleMapGadget_BindGadgetItemEvent(Gadget, Item, Callback, EventType)
	
	If EventType = #PB_All
		
		EventType = #PB_EventType_GoogleMapMarker_AnimationChanged | 
		            #PB_EventType_GoogleMapMarker_Click | 
		            #PB_EventType_GoogleMapMarker_ClickableChanged | 
		            #PB_EventType_GoogleMapMarker_CursorChanged | 
		            #PB_EventType_GoogleMapMarker_DblClick | 
		            #PB_EventType_GoogleMapMarker_Drag | 
		            #PB_EventType_GoogleMapMarker_DragEnd | 
		            #PB_EventType_GoogleMapMarker_DraggableChanged | 
		            #PB_EventType_GoogleMapMarker_DragStart | 
		            #PB_EventType_GoogleMapMarker_FlatChanged | 
		            #PB_EventType_GoogleMapMarker_IconChanged | 
		            #PB_EventType_GoogleMapMarker_MouseDown | 
		            #PB_EventType_GoogleMapMarker_MouseOut | 
		            #PB_EventType_GoogleMapMarker_MouseOver | 
		            #PB_EventType_GoogleMapMarker_MouseUp | 
		            #PB_EventType_GoogleMapMarker_PositionChanged | 
		            #PB_EventType_GoogleMapMarker_RightClick | 
		            #PB_EventType_GoogleMapMarker_ShapeChanged | 
		            #PB_EventType_GoogleMapMarker_TitleChanged | 
		            #PB_EventType_GoogleMapMarker_VisibleChanged | 
		            #PB_EventType_GoogleMapMarker_ZIndexChanged

		
	EndIf	
	
	Protected myMarker
	
	!	var selector = $("#g_" + Gadget);
	!	var myMarkerArray = selector.data("markerarray");
	!	myMarker = myMarkerArray[Item];
	
	If myMarker
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_AnimationChanged)) {
		!  google.maps.event.addListener(myMarker, "animation_changed", function () {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_AnimationChanged;
		!   Callback(Item);
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_Click)) {
		!  google.maps.event.addListener(myMarker, "click", function (event) {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_Click;
		!   Callback(Item, event.latLng.lat(), event.latLng.lng());
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_ClickableChanged)) {
		!  google.maps.event.addListener(myMarker, "clickable_changed", function () {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_ClickableChanged;
		!   Callback(Item);
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_CursorChanged)) {
		!  google.maps.event.addListener(myMarker, "cursor_changed", function () {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_CursorChanged;
		!   Callback(Item);
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_DblClick)) {
		!  google.maps.event.addListener(myMarker, "dblclick", function (event) {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_DblClick;
		!   Callback(Item, event.latLng.lat(), event.latLng.lng());
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_Drag)) {
		!  google.maps.event.addListener(myMarker, "drag", function (event) {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_Drag;
		!   Callback(Item, event.latLng.lat(), event.latLng.lng());
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_DragEnd)) {
		!  google.maps.event.addListener(myMarker, "dragend", function (event) {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_DragEnd;
		!   Callback(Item, event.latLng.lat(), event.latLng.lng());
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_DraggableChanged)) {
		!  google.maps.event.addListener(myMarker, "draggable_changed", function () {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_DraggableChanged;
		!		Callback(Item);
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_DragStart)) {
		!  google.maps.event.addListener(myMarker, "dragstart", function (event) {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_DragStart;
		!		Callback(Item, event.latLng.lat(), event.latLng.lng());
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_FlatChanged)) {
		!  google.maps.event.addListener(myMarker, "flat_changed", function () {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_FlatChanged;
		!		Callback(Item);
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_IconChanged)) {
		!  google.maps.event.addListener(myMarker, "icon_changed", function () {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_IconChanged;
		!		Callback(Item);
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_MouseDown)) {
		!  google.maps.event.addListener(myMarker, "mousedown", function (event) {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_MouseDown;
		!		Callback(Item, event.latLng.lat(), event.latLng.lng());
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_MouseOut)) {
		!  google.maps.event.addListener(myMarker, "mouseout", function (event) {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_MouseOut;
		!		Callback(Item, event.latLng.lat(), event.latLng.lng());
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_MouseOver)) {
		!  google.maps.event.addListener(myMarker, "mouseover", function (event) {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_MouseOver;
		!		Callback(Item, event.latLng.lat(), event.latLng.lng());
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_MouseUp)) {
		!  google.maps.event.addListener(myMarker, "mouseup", function (event) {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_MouseUp;
		!		Callback(Item, event.latLng.lat(), event.latLng.lng());
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_PositionChanged)) {
		!  google.maps.event.addListener(myMarker, "position_changed", function () {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_PositionChanged;
		!		Callback(Item);
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_RightClick)) {
		!  google.maps.event.addListener(myMarker, "rightclick", function (event) {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_RightClick;
		!		Callback(Item, event.latLng.lat(), event.latLng.lng());
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_ShapeChanged)) {
		!  google.maps.event.addListener(myMarker, "shape_changed", function () {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_ShapeChanged;
		!		Callback(Item);
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_TitleChanged)) {
		!  google.maps.event.addListener(myMarker, "title_changed", function () {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_TitleChanged;
		!		Callback(Item);
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_VisibleChanged)) {
		!  google.maps.event.addListener(myMarker, "visible_changed", function () {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_VisibleChanged;
		!		Callback(Item);
		!  });
		! }
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_ZIndexChanged)) {
		!  google.maps.event.addListener(myMarker, "zindex_changed", function () {
		!   cEvent.eventGadget = Gadget;
		!   cEvent.eventType = PB_EventType_GoogleMapMarker_ZIndexChanged;
		!		Callback(Item);
		!  });
		! }
		
	Else
		
		Debug("GoogleMapGadgetBindGadgetItemEvent(): marker " + Str(Item) + " not found")
		
	EndIf
	
EndProcedure
RegisterUserGadgetProcedure("GoogleMapGadget", "BindGadgetItemEvent", @GoogleMapGadget_BindGadgetItemEvent())

Procedure GoogleMapGadget_UnbindGadgetItemEvent(Gadget, Item, Callback, EventType)
	
	Protected myMarker
	
	!	var selector = $("#g_" + Gadget);
	
	If EventType = #PB_All
		
		EventType = #PB_EventType_GoogleMapMarker_AnimationChanged | 
		            #PB_EventType_GoogleMapMarker_Click | 
		            #PB_EventType_GoogleMapMarker_ClickableChanged | 
		            #PB_EventType_GoogleMapMarker_CursorChanged | 
		            #PB_EventType_GoogleMapMarker_DblClick | 
		            #PB_EventType_GoogleMapMarker_Drag | 
		            #PB_EventType_GoogleMapMarker_DragEnd | 
		            #PB_EventType_GoogleMapMarker_DraggableChanged | 
		            #PB_EventType_GoogleMapMarker_DragStart | 
		            #PB_EventType_GoogleMapMarker_FlatChanged | 
		            #PB_EventType_GoogleMapMarker_IconChanged | 
		            #PB_EventType_GoogleMapMarker_MouseDown | 
		            #PB_EventType_GoogleMapMarker_MouseOut | 
		            #PB_EventType_GoogleMapMarker_MouseOver | 
		            #PB_EventType_GoogleMapMarker_MouseUp | 
		            #PB_EventType_GoogleMapMarker_PositionChanged | 
		            #PB_EventType_GoogleMapMarker_RightClick | 
		            #PB_EventType_GoogleMapMarker_ShapeChanged | 
		            #PB_EventType_GoogleMapMarker_TitleChanged | 
		            #PB_EventType_GoogleMapMarker_VisibleChanged | 
		            #PB_EventType_GoogleMapMarker_ZIndexChanged

		
	EndIf	
	
	!	var myMarkerArray = selector.data("markerarray");
	
	!	myMarker = myMarkerArray[Item];
	
	If myMarker
		
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_AnimationChanged)) google.maps.event.clearListeners(myMarker, "animation_changed");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_Click))            google.maps.event.clearListeners(myMarker, "click");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_ClickableChanged)) google.maps.event.clearListeners(myMarker, "clickable_changed");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_CursorChanged))    google.maps.event.clearListeners(myMarker, "cursor_changed");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_DblClick))         google.maps.event.clearListeners(myMarker, "dblclick");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_Drag))             google.maps.event.clearListeners(myMarker, "drag");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_DragEnd))          google.maps.event.clearListeners(myMarker, "dragend");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_DraggableChanged)) google.maps.event.clearListeners(myMarker, "draggable_changed");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_DragStart))        google.maps.event.clearListeners(myMarker, "dragstart");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_FlatChanged))      google.maps.event.clearListeners(myMarker, "flat_changed");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_IconChanged))      google.maps.event.clearListeners(myMarker, "icon_changed");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_MouseDown))        google.maps.event.clearListeners(myMarker, "mousedown");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_MouseOut))         google.maps.event.clearListeners(myMarker, "mouseout");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_MouseOver))        google.maps.event.clearListeners(myMarker, "mouseover");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_MouseUp))          google.maps.event.clearListeners(myMarker, "mouseup");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_PositionChanged))  google.maps.event.clearListeners(myMarker, "position_changed");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_RightClick))       google.maps.event.clearListeners(myMarker, "rightclick");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_ShapeChanged))     google.maps.event.clearListeners(myMarker, "shape_changed");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_TitleChanged))     google.maps.event.clearListeners(myMarker, "title_changed");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_VisibleChanged))   google.maps.event.clearListeners(myMarker, "visible_changed");
		! if (cCommon.CheckFlag(EventType, PB_EventType_GoogleMapMarker_ZIndexChanged))    google.maps.event.clearListeners(myMarker, "zindex_changed");
		
	Else
		
		Debug("UnbindGadgetItemEvent(): marker not found")
		
	EndIf
	
EndProcedure
RegisterUserGadgetProcedure("GoogleMapGadget", "UnbindGadgetItemEvent", @GoogleMapGadget_UnbindGadgetItemEvent())

; -----------------------------

Procedure GoogleMapGadget_AddPolyline(Gadget, Position = -1, Options.s = "")
	
	!	var selector = $("#g_" + Gadget);
	!	var myMap = selector.data("googlemap");
	!	var myPolylineArray = selector.data("polylinearray");
	
	! var myPolylineOptions = { strokeColor: '#000000', strokeOpacity: 1.0, strokeWeight: 3 }
	
	!	if (Options != "") {
	!		Options = cString.ReplaceString(Options, "'", cString.Chr(34));
	!		myPolylineOptions = JSON.parse(Options);
	!	}
	
	!	var myPolyline = new google.maps.Polyline(myPolylineOptions);
	!	myPolyline.setMap(myMap);
	
	! if (Position == -1) Position = myPolylineArray.length;
	! if (Position < 0) Position = 0;
	! if (Position > myPolylineArray.length) Position = myPolylineArray.length;
	
	!	myPolylineArray.splice(Position, 0, myPolyline);
	!	selector.data("polylinearray", myPolylineArray)	
	
EndProcedure

Procedure GoogleMapGadget_RemovePolyline(Gadget, Position)
	
	!	var selector = $("#g_" + Gadget);
	!	var myPolylineArray = selector.data("polylinearray");
	!	var myPolyline = myPolylineArray[Position];
	!	myPolyline.setMap(null);
	!	myPolylineArray.splice(Position, 1);
	!	selector.data("polylinearray", myPolylineArray)	
	
EndProcedure

Procedure GoogleMapGadget_AddPolylineItem(Gadget, Polyline, Position, Item)
	
	!	var selector = $("#g_" + Gadget);
	!	var myPolylineArray = selector.data("polylinearray");	
	! var myPolyline = myPolylineArray[Polyline];
	
	! var latlng;
	
	!	if (typeof Item === 'string') {
	!		latlng = new google.maps.LatLng(Item.split(',')[0],Item.split(',')[1]);
	!	} else {
	!		var myMarkerArray = selector.data("markerarray");
	! 	var myMarker = myMarkerArray[Item];
	!		latlng = myMarker.getPosition();
	!	}
	
	! var myPath = myPolyline.getPath();
	
	! if (Position == -1) Position = myPath.getLength();
	! if (Position < 0) Position = 0;
	! if (Position > myPath.getLength()) Position = myPath.getLength();
	
	! myPath.insertAt(Position, latlng);
	
EndProcedure

Procedure GoogleMapGadget_RemovePolylineItem(Gadget, Polyline, Position)
	
	!	var selector = $("#g_" + Gadget);
	!	var myPolylineArray = selector.data("polylinearray");	
	! var myPolyline = myPolylineArray[Polyline];
	
	! var myPath = myPolyline.getPath();
	
	! if (Position == -1) Position = myPath.getLength();
	! if (Position < 0) Position = 0;
	! if (Position > myPath.getLength()) Position = myPath.getLength();
	
	! myPath.removeAt(Position);
	
EndProcedure

Procedure GoogleMapGadget_ClearPolylineItems(Gadget, Polyline)
	
	!	var selector = $("#g_" + Gadget);
	!	var myPolylineArray = selector.data("polylinearray");	
	! var myPolyline = myPolylineArray[Polyline];
	! myPolyline.getPath().clear();
	
EndProcedure

Procedure GoogleMapGadget_ClearPolylines(Gadget)
	!	var selector = $("#g_" + Gadget);
	!	var myPolylineArray = selector.data("polylinearray");	
	! for (var i=0; i<myPolylineArray.length; i++) {
	! 	var myPolyline = myPolylineArray[i];
	! 	myPolyline.getPath().clear();
	!		myPolyline.setMap(null);
	! }
	! selector.data("polylinearray", []);
EndProcedure

; -----------------------------

Procedure GoogleMapsGeocoder(Address, marker)
	
	!	var geocoder = new google.maps.Geocoder();
	
	!	geocoder.geocode({ 'address': Address }, function (results, status) {
	!		if (status === google.maps.GeocoderStatus.OK) {
	!			if (status !== google.maps.GeocoderStatus.ZERO_RESULTS) {
	!				marker.setPosition(results[0].geometry.location);
	!			} else {
	!				cDebugger.Debug("No results found");
	!			}
	!		} else {
	!			cDebugger.Debug("Geocode was not successful for the following reason: " + status);
	!		}
	!	});
	
EndProcedure

Procedure GoogleMapsGeocoder2(Address.s, CallbackOnSucces, CallbackOnError)

	!	var geocoder = new google.maps.Geocoder();
	
	!	geocoder.geocode({ 'address': Address }, function (results, status) {
	!		if (status === google.maps.GeocoderStatus.OK) {
	!			if (status !== google.maps.GeocoderStatus.ZERO_RESULTS) {
	
	!				var CSV = "";
	
	!				$.each(results, function (key, result) {
	
	!					CSV += result.formatted_address + ";"
	!					CSV += result.geometry.location + "\n"
	
	!				});
	!
	!				CallbackOnSucces(CSV);
	
	!			} else {
	!				CallbackOnError("No results found");
	!			}
	!		} else {
	!			CallbackOnError("Geocode was not successful for the following reason: " + status);
	!		}
	!	});

EndProcedure

Procedure GoogleMapsGeocoder3(lat, lng, CallbackOnSuccess, CallbackOnError)
!  var latlng = new google.maps.LatLng(lat, lng);
!  var geocoder = new google.maps.Geocoder();
!  geocoder.geocode({ 'latLng': latlng }, function (results, status) {
!    if (status == google.maps.GeocoderStatus.OK) {
!      if (status !== google.maps.GeocoderStatus.ZERO_RESULTS) {
!        var CSV = "";
!        $.each(results, function (key, result) {
!          CSV += result.formatted_address + ";"
!          CSV += result.geometry.location + "\n"
!        });
!        CallbackOnSuccess(CSV);
!      } else {
!        CallbackOnError("No results found");
!      }
!    } else {
!      CallbackOnError("Geocode was not successful for the following reason: " + status);
!    }
!  });
EndProcedure

; -----------------------------

Procedure GoogleMapGadget(Gadget, x, y, Width, Height, Flags = 0)
	
	!	var Gadget = cCommon.SetGadgetAndStuff(Gadget);
	!	var selector = $("<div />");
	!	selector.attr("id", "g_" + Gadget);
	
	!	if (cCommon.CheckFlag(Flags, PB_GoogleMap_Border)) {
	!		selector.css("border", "1px solid black");
	!	}
	
	!	var myOptions = {
	!		center: new google.maps.LatLng(0, 0),
	!		mapTypeId: google.maps.MapTypeId.SATELLITE,
	!		zoom: 1
	!	};
	
	!	var myMap = new google.maps.Map(selector[0], myOptions);
	
	!	cCommon.SetGadgetPosition(selector, x, y, Width, Height);
	
	!	cCommon.CurrentContainer.append(selector);
	
	!	selector.data("googlemap", myMap);
	!	selector.data("markerarray", []);
	!	selector.data("polylinearray", []);
  ! selector.data("markerclusterer", new MarkerClusterer(myMap, []))
  !	selector.data("usemarkerclusterer", false);
  
	!	google.maps.event.trigger(myMap, 'resize');
	
	!	selector.data("GadgetType", "GoogleMapGadget");
	
	!	return Gadget;
	
EndProcedure

; IDE Options = PureBasic 5.41 LTS Beta 1 (Windows - x86)
; CursorPosition = 1085
; FirstLine = 11
; Folding = AAAA9
; EnableXP