﻿; PatternLockGadget-Include

; http://ignitersworld.com/lab/patternLock.html

EnableExplicit

OpenLibrary(#PB_Any, "userlibraries/patternLock/patternLock.css")
OpenLibrary(#PB_Any, "userlibraries/patternLock/patternLock.min.js")

Enumeration
	#PB_PatternLock_Error = 1
	#PB_PatternLock_Reset = 2
EndEnumeration

Procedure PatternLockGadget_GetGadgetState(Gadget)
	!	var selector = $("#g_" + Gadget);
	! try { return selector.data("patternlock").getPattern(); }
	! catch (e) { return ""; }
EndProcedure
RegisterUserGadgetProcedure("PatternLockGadget", "GetGadgetState", @PatternLockGadget_GetGadgetState())

Procedure PatternLockGadget_SetGadgetState(Gadget, State)
	
	!	var selector = $("#g_" + Gadget);
	If State = #PB_PatternLock_Error
		!	selector.data("patternlock").error();
	ElseIf State = #PB_PatternLock_Reset
		!	selector.data("patternlock").reset();
	EndIf
	
EndProcedure
RegisterUserGadgetProcedure("PatternLockGadget", "SetGadgetState", @PatternLockGadget_SetGadgetState())

Procedure PatternLockGadget(Gadget, x, y, Callback, Columns = 3, Rows = 3)
	
	!	var Gadget = cCommon.SetGadgetAndStuff(Gadget);
	!	var selector = $("<div />");
	!	selector.attr("id", "g_" + Gadget);
	
	!	cCommon.CurrentContainer.append(selector);
	
	!	selector.css({ "position": "absolute", "top": y, "left": x });
	
	!	var myPatternLock = new PatternLock(selector, {
	!		matrix: [Rows, Columns],
	!		onDraw: function (pattern) {
	!			if (Callback) Callback(pattern);
	!		}
	!	});
	!
	!	selector.data("patternlock", myPatternLock);
	
	!	selector.find(".patt-wrap").css("padding-left", "20px");
	!	selector.find(".patt-wrap").css("padding-top", "10px");
	
	!	selector.data("GadgetType", "PatternLockGadget");
	
	!	return Gadget;
	
EndProcedure


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 17
; FirstLine = 9
; Folding = -
; EnableXP