XIncludeFile "..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

Procedure OverWriteDefaultSettings()
	
	; if you want to customize BlockUI, you
	; can overwrite the default settings.
	
	; see also: http://malsup.com/jquery/block/#options
	
	EnableJS
	;
	;// override these in your code to change the default behavior and style 
	;
	;$.blockUI.defaults = {
	;    // message displayed when blocking (use null for no message) 
	;    message: '<h1>Please wait...</h1>',
	;    title: null, // title string; only used when theme == true 
	;    draggable: true, // only used when theme == true (requires jquery-ui.js to be loaded) 
	;    theme: false, // set to true to use with jQuery UI themes 
	;    // styles for the message when blocking; if you wish to disable 
	;    // these and use an external stylesheet then do this in your code: 
	;    // $.blockUI.defaults.css = {}; 
	;    css: {
	;        padding: 0,
	;        margin: 0,
	;        width: '30%',
	;        top: '40%',
	;        left: '35%',
	;        textAlign: 'center',
	;        color: '#000',
	;        border: '3px solid #aaa',
	;        backgroundColor: '#fff',
	;        cursor: 'wait'
	;    },
	;    // minimal style set used when themes are used 
	;    themedCSS: {
	;        width: '30%',
	;        top: '40%',
	;        left: '35%'
	;    },
	;    // styles for the overlay 
	;    overlayCSS: {
	;        backgroundColor: '#000',
	;        opacity: 0.6,
	;        cursor: 'wait'
	;    },
	;    // style to replace wait cursor before unblocking to correct issue 
	;    // of lingering wait cursor 
	;    cursorReset: 'default',
	;    // styles applied when using $.growlUI 
	;    growlCSS: {
	;        width: '350px',
	;        top: '10px',
	;        left: '',
	;        right: '10px',
	;        border: 'none',
	;        padding: '5px',
	;        opacity: 0.6,
	;        cursor: null,
	;        color: '#fff',
	;        backgroundColor: '#000',
	;        '-webkit-border-radius': '10px',
	;        '-moz-border-radius': '10px'
	;    },
	;    // force usage of iframe in non-IE browsers (handy for blocking applets) 
	;    forceIframe: false,
	;    // z-index for the blocking overlay 
	;    baseZ: 1000,
	;    // set these to true to have the message automatically centered 
	;    centerX: true, // <-- only effects element blocking (page block controlled via css above) 
	;    centerY: true,
	;    // allow body element to be stetched in ie6; this makes blocking look better 
	;    // on "short" pages.  disable if you wish to prevent changes to the body height 
	;    allowBodyStretch: true,
	;    // enable if you want key and mouse events to be disabled for content that is blocked 
	;    bindEvents: true,
	;    // be default blockUI will supress tab navigation from leaving blocking content 
	;    // (if bindEvents is true) 
	;    constrainTabKey: true,
	;    // fadeIn time in millis; set to 0 to disable fadeIn on block 
	;    fadeIn: 200,
	;    // fadeOut time in millis; set to 0 to disable fadeOut on unblock 
	;    fadeOut: 400,
	;    // time in millis to wait before auto-unblocking; set to 0 to disable auto-unblock 
	;    timeout: 0,
	;    // disable if you don't want to show the overlay 
	;    showOverlay: true,
	;    // if true, focus will be placed in the first available input field when 
	;    // page blocking 
	;    focusInput: true,
	;    // suppresses the use of overlay styles on FF/Linux (due to performance issues with opacity) 
	;    // no longer needed in 2012 
	;    // applyPlatformOpacityRules: true, 
	;    // callback method invoked when fadeIn has completed and blocking message is visible 
	;    onBlock: null,
	;    // callback method invoked when unblocking has completed; the callback is 
	;    // passed the element that has been unblocked (which is the window object for page 
	;    // blocks) and the options that were passed to the unblock call: 
	;    //   onUnblock(element, options) 
	;    onUnblock: null,
	;    // don't ask; if you really must know: http://groups.google.com/group/jquery-en/browse_thread/thread/36640a8730503595/2f6a79a77a78e493#2f6a79a77a78e493 
	;    quirksmodeOffsetHack: 4,
	;    // class name of the message block 
	;    blockMsgClass: 'blockMsg',
	;    // if it is already blocked, then ignore it (don't unblock and reblock) 
	;    ignoreIfBlocked: false
	;};
	DisableJS
	
EndProcedure

Enumeration
	#Desktop
	#cmdBlockDesktop
	#cmdBlockWindow
	#cmdBlockGadget
	#TwoSecondsTimer
	#Window
	#Gadget
EndEnumeration

Procedure DisableButtons(Flag)
	DisableGadget(#cmdBlockDesktop, Flag)
	DisableGadget(#cmdBlockWindow, Flag)
	DisableGadget(#cmdBlockGadget, Flag)
EndProcedure

; *** Block Desktop ***

Procedure UnblockDesktop()
	
	P2W_BlockWindow(#Desktop, #False)
	
	UnbindEvent(#PB_Event_Timer, @UnblockDesktop(), #Desktop, #TwoSecondsTimer)
	
	DisableButtons(#False)

EndProcedure

Procedure BlockDesktop_Ready()
	
	BindEvent(#PB_Event_Timer, @UnblockDesktop(), #Desktop, #TwoSecondsTimer)
	
EndProcedure

Procedure BlockDesktop()
	
	DisableButtons(#True)

	P2W_BlockWindow(#Desktop, #True, "Desktop is blocked for 2 seconds...", "", @BlockDesktop_Ready())
	
EndProcedure

; *** Block Window ***

Procedure UnblockWindow()
	
	P2W_BlockWindow(#Window, #False)
	
	UnbindEvent(#PB_Event_Timer, @UnblockDesktop(), #Desktop, #TwoSecondsTimer)
	
	DisableButtons(#False)

EndProcedure

Procedure BlockWindow_Ready()
	
	BindEvent(#PB_Event_Timer, @UnblockWindow(), #Desktop, #TwoSecondsTimer)
	
EndProcedure

Procedure BlockWindow()
	
	DisableButtons(#True)

	P2W_BlockWindow(#Window, #True, "Window is blocked for 2 seconds...", "", @BlockWindow_Ready())
	
EndProcedure

; *** Block Gadget ***

Procedure UnblockGadget()
	
	P2W_BlockGadget(#Gadget, #False)
	
	UnbindEvent(#PB_Event_Timer, @UnblockDesktop(), #Desktop, #TwoSecondsTimer)
	
	DisableButtons(#False)

EndProcedure

Procedure BlockGadget_Ready()
	
	BindEvent(#PB_Event_Timer, @UnblockGadget(), #Desktop, #TwoSecondsTimer)
	
EndProcedure

Procedure BlockGadget()
	
	DisableButtons(#True)
	
	P2W_BlockGadget(#Gadget, #True, "Gadget is blocked for 2 seconds...", "", @BlockGadget_Ready())
	
EndProcedure

; -------------

P2W_SetDesktopID(#Desktop)

ButtonGadget(#cmdBlockDesktop, 10, 10, 300, 30, "Block Desktop for 2 seconds...")
BindGadgetEvent(#cmdBlockDesktop, @BlockDesktop())

ButtonGadget(#cmdBlockWindow, 10, 50, 300, 30, "Block Window for 2 seconds...")
BindGadgetEvent(#cmdBlockWindow, @BlockWindow())

ButtonGadget(#cmdBlockGadget, 10, 90, 300, 30, "Block Gadget for 2 seconds...")
BindGadgetEvent(#cmdBlockGadget, @BlockGadget())

OpenWindow(#Window, 200, 200, 400, 300, "Window", #PB_Window_NoGadgets)
PanelGadget(#Gadget, 20, 20, 320, 260)
AddGadgetItem(#Gadget, -1, "Tab1")
AddGadgetItem(#Gadget, -1, "Tab2")
CloseGadgetList()
SetGadgetState(#Gadget, 0)

AddWindowTimer(#Desktop, #TwoSecondsTimer, 2000)

; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 206
; Folding = AA-
; EnableXP