﻿XIncludeFile "..\..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

UseCordova()

XIncludeFile "Geolocation.pbi"

Enumeration
	#cmdGetCurrentPosition
	#lblTimestamp
	#lblLongitude
	#lblLatitude
	#lblAltitude
	#lblAccuracy
	#lblAltitudeAccuracy
	#lblHeading
	#lblSpeed
EndEnumeration

Structure sCoords
	speed.f
	heading.f
	altitudeAccuracy.f
	accuracy.f
	altitude.f
	longitude.f
	latitude.f
EndStructure

Structure sPosition
	timestamp.q
	coords.sCoords
EndStructure

Structure sError
	code.s
	message.s
EndStructure

Procedure GeolocationOnSuccess(*position.sPosition)
	
	SetGadgetText(#lblTimestamp,         "Timestamp: "          + Str(*position\timestamp))
 	SetGadgetText(#lblLongitude,         "Longitude: "          + Str(*position\coords\longitude))
 	SetGadgetText(#lblLatitude,          "Latitude: "           + Str(*position\coords\latitude))
 	SetGadgetText(#lblAltitude,          "Altitude: "           + Str(*position\coords\altitude))
 	SetGadgetText(#lblAccuracy,          "Accuracy: "           + Str(*position\coords\accuracy))
 	SetGadgetText(#lblAltitudeAccuracy,  "Altitude Accuracy: "  + Str(*position\coords\altitudeAccuracy))
 	SetGadgetText(#lblHeading,           "Heading: "            + Str(*position\coords\heading))
 	SetGadgetText(#lblSpeed,             "Speed: "              + Str(*position\coords\speed))
 	
EndProcedure

Procedure GeolocationOnError(*Error.sError)
	
	Debug "Error"
	Debug "Code: " + *Error\code
	Debug "Message: " + *Error\message
	
EndProcedure

Global GeolocationConfig

	! GeolocationConfig = {
	!    enableHighAccuracy: true,
	!    timeout: 30000,
	!    maximumAge: 18000000
	! }	
	
Procedure GetCurrentPositionButtonEvent()
	GeolocationGetCurrentPosition(@GeolocationOnSuccess(), @GeolocationOnError(), GeolocationConfig);
EndProcedure

Procedure WatchPositionButtonEvent()
	GeolocationWatchPosition(@GeolocationOnSuccess(), @GeolocationOnError(), GeolocationConfig);
EndProcedure

Procedure onDeviceReady()
	
	ButtonGadget(#cmdGetCurrentPosition, 10, 10, 300, 30, "GetCurrentPosition")
	BindGadgetEvent(#cmdGetCurrentPosition, @GetCurrentPositionButtonEvent())
	
	TextGadget(#lblTimestamp,         10,  60, 300, 20, "Timestamp:", #PB_Text_Border)
	TextGadget(#lblLatitude,          10,  90, 300, 20, "Latitude:",  #PB_Text_Border)
	TextGadget(#lblLongitude,         10, 120, 300, 20, "Longitude:", #PB_Text_Border)
	TextGadget(#lblAltitude,          10, 150, 300, 20, "Altitude:", #PB_Text_Border)
	TextGadget(#lblAccuracy,          10, 180, 300, 20, "Accuracy:", #PB_Text_Border)
	TextGadget(#lblAltitudeAccuracy,  10, 210, 300, 20, "Altitude Accuracy:", #PB_Text_Border)
	TextGadget(#lblHeading,           10, 240, 300, 20, "Heading:", #PB_Text_Border)
	TextGadget(#lblSpeed,             10, 270, 300, 20, "Speed:", #PB_Text_Border)
	
EndProcedure

! document.addEventListener("deviceready", onDeviceReady, false);


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 95
; FirstLine = 47
; Folding = --
; EnableUnicode
; EnableXP