XIncludeFile "..\..\p2w.pbi"

XIncludeFile "..\..\p2w_w2ui_grid.pbi"

P2W_Converter_SetProfile("pb2webtest")

EnableExplicit

Enumeration
	#myGridGadget
	#myButton
EndEnumeration

Structure sRecord
	recid.s
	fname.s
	lname.s
	email.s
	birthday.s
EndStructure

Procedure myButton_Event()
	
	Protected Result.s
	
	Result = GetGadgetText(#myGridGadget, #PB_ListIcon_Changed)
	
	ParseJSON(0, Result)
	
	If JSONArraySize(JSONValue(0)) > 0
		
		Debug ComposeJSON(0)
		
		NewList Changes()
		
		ExtractJSONList(JSONValue(0), Changes())
		
		Protected *ChangedItem.sRecord
		
		ForEach Changes()
			
			*ChangedItem = Changes()
			
			If *ChangedItem\recid
				Debug "recid:    " + *ChangedItem\recid
			EndIf
			
			If *ChangedItem\fname
				Debug "fname:    " + *ChangedItem\fname
			EndIf
			
			If *ChangedItem\lname
				Debug "lname:    " + *ChangedItem\lname
			EndIf
			
			If *ChangedItem\email
				Debug "email:    " + *ChangedItem\email
			EndIf
			
			If *ChangedItem\birthday
				Debug "birthday: " + *ChangedItem\birthday
			EndIf
			
			Debug "---"
			
		Next
		
	Else
		
		Debug "No changes"
		
	EndIf
	
EndProcedure

ButtonGadget(#myButton, 10, 10, 300, 30, "Get Changes")

BindGadgetEvent(#myButton, @myButton_Event())

OpenWindow(0, #PB_Ignore, #PB_Ignore, 800, 600, "ListIconGadget", #PB_Window_ScreenCentered)

ListIconGadget(#myGridGadget, 10, 10, 780, 580, "ListIconGadget", 0)

SetGadgetAttribute(#myGridGadget, #PB_ListIcon_HeaderText, @"This is a header")
 
Procedure.s myRenderer(*record.sRecord, index, column_index)
	
	Select LCase(*record\lname)
		Case "wayne"
			ProcedureReturn "<div style='color:red'>" + *record\lname + "</div>"
		Default
			ProcedureReturn *record\lname
	EndSelect
	
EndProcedure

; -------

; ################
; # Columns
; ################

NewList Columns.s_ListIcon_Column()

; ---

AddElement(Columns())
Columns()\field     = "recid"
Columns()\caption   = "ID"
Columns()\size      = "50px"
Columns()\attr      = "align=center"
Columns()\sortable  = #True
Columns()\resizable = #True

; ---

AddElement(Columns())
Columns()\field     = "lname"
Columns()\caption   = "Last Name"
Columns()\size      = "30%"
Columns()\sortable  = #True
Columns()\resizable = #True
Columns()\render    = @myRenderer()


; define Edit-Type:
NewMap myMap.s()
myMap("type") = "text"
CreateJSON(0)
InsertJSONMap(JSONValue(0), myMap())
Columns()\editable  = JSONValue(0)

; ---

AddElement(Columns())
Columns()\field     = "fname"
Columns()\caption   = "First Name"
Columns()\size      = "30%"
Columns()\sortable  = #True
Columns()\resizable = #True
Columns()\style     = "color:blue"

; ---

AddElement(Columns())
Columns()\field     = "birthday"
Columns()\caption   = "Birthday"
Columns()\size      = "100%"
Columns()\resizable = #True
Columns()\render    = @"date:dd.mm.yyyy"

; define Edit-Type:

NewMap myMap.s()
myMap("type") = "date"
CreateJSON(0)
InsertJSONMap(JSONValue(0), myMap())
Columns()\editable  = JSONValue(0)
FreeJSON(0)

; ---

CreateJSON(0)
InsertJSONList(JSONValue(0), Columns())
SetGadgetAttribute(#myGridGadget, #PB_ListIcon_Columns, JSONValue(0))
FreeJSON(0)

; ################
; # Records
; ################

NewList Records.sRecord()

AddElement(Records())
Records()\recid = "1"
Records()\fname = "Peter"
Records()\lname = "Parker"

AddElement(Records())
Records()\recid    = "2"
Records()\fname    = "Bruce"
Records()\lname    = "Wayne"
Records()\birthday = Str(MomentFromDate(Date()))

AddElement(Records())
Records()\recid = "3"
Records()\fname = "Clark"
Records()\lname = "Kent"

CreateJSON(0)
InsertJSONList(JSONValue(0), Records())
SetGadgetAttribute(#myGridGadget, #PB_ListIcon_Records, JSONValue(0))
FreeJSON(0)

; ################
; # SearchFields
; ################

NewList SearchFields.s_ListIcon_Search()

AddElement(SearchFields())
SearchFields()\field = "lname"
SearchFields()\caption = "Last name"
SearchFields()\type = "text"


CreateJSON(0)
InsertJSONList(JSONValue(0), SearchFields())
SetGadgetAttribute(#myGridGadget, #PB_ListIcon_SearchFields, JSONValue(0))
FreeJSON(0)

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 180
; FirstLine = 84
; Folding = w
; EnableUnicode
; EnableXP