XIncludeFile "..\..\p2w.pbi"

XIncludeFile "..\..\p2w_w2ui_grid.pbi"

EnableExplicit

Enumeration FormWindow
	#Desktop
	#Window_0
EndEnumeration

Enumeration FormGadget
	#chkHeader
	#chkToolbar
	#chkToolbarReload
	#chkToolbarColumns
	#chkToolbarSearch
	#chkToolbarAdd
	#chkToolbarEdit
	#chkToolbarDelete
	#chkToolbarSave
	#chkFooter
	#chkColumnHeaders
	#chkLineNumbers
	#chkExpandColumn
	#chkSelectColumn
	#chkEmptyRecords
	#chkSelectionBorder
	#chkRecordTitles
	#chkSkipRecords
	#chkMultiSelect
	#chkHeaderDragDrop
	#chkSelectTypeCell
	#chkColumn2Sortable
	#chkColumn2Resizable
	#chkColumn2Editable
	#ListIconGadget
EndEnumeration

Procedure ButtonEvents()
	
	Protected Value
	
	Value = GetGadgetState(EventGadget())
	
	Select EventGadget()
			
		Case #chkHeader
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_Header, Value) ; indicates if header is visible
			
		Case #chkToolbar
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_Toolbar, Value) ; indicates if toolbar is visible
			
		Case #chkFooter
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_Footer, Value) ; indicates if footer is visible
			
		Case #chkColumnHeaders
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_ColumnHeaders, Value) ; indicates if columns is visible
			
		Case #chkLineNumbers
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_LineNumbers, Value) ; indicates if line numbers column is visible
			
		Case #chkExpandColumn
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_ExpandColumn, Value) ; indicates if expand column is visible
			
		Case #chkSelectColumn
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_SelectColumn, Value) ; indicates if select column is visible
			
		Case #chkEmptyRecords
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_EmptyRecords, Value) ; indicates if empty records are visible
			
		Case #chkToolbarReload
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_ToolbarReload, Value) ; indicates if toolbar reload button is visible
			
		Case #chkToolbarColumns
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_ToolbarColumns, Value) ; indicates if toolbar columns button is visible
			
		Case #chkToolbarSearch
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_ToolbarSearch, Value) ; indicates if toolbar search controls are visible
			
		Case #chkToolbarAdd
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_ToolbarAdd, Value) ; indicates if toolbar add new button is visible
			
		Case #chkToolbarEdit
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_ToolbarEdit, Value) ; indicates if toolbar edit button is visible
			
		Case #chkToolbarDelete
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_ToolbarDelete, Value) ; indicates if toolbar delete button is visible
			
		Case #chkToolbarSave
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_ToolbarSave, Value) ; indicates if toolbar save button is visible
			
		Case #chkSelectionBorder
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_SelectionBorder, Value) ; display border arround selection (for selectType = 'cell')
			
		Case #chkRecordTitles
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_RecordTitles, Value) ; indicates if to define titles for records
			
		Case #chkSkipRecords
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_SkipRecords, Value) ; indicates if skip records should be visible
			
		Case #chkMultiSelect
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_MultiSelect, Value) ; indicates if skip records should be visible
			
		Case #chkHeaderDragDrop
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_HeaderDragDrop, Value) ; indicates if skip records should be visible
			
		Case #chkSelectTypeCell
			SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_SelectTypeCell, Value) ; indicates if skip records should be visible
			
		Case #chkColumn2Editable
			
			If Value 
				ParseJSON(0, "{ " + Chr(34) + "type" + Chr(34) + " : " + Chr(34) + "text" + Chr(34) + " }")
				SetGadgetItemAttribute(#ListIconGadget, #PB_Ignore, #PB_ListIcon_Editable, JSONValue(0), 1)
				FreeJSON(0)
			Else
				SetGadgetItemAttribute(#ListIconGadget, #PB_Ignore, #PB_ListIcon_Editable, #Null, 1)
			EndIf
			
		Case #chkColumn2Resizable
			SetGadgetItemAttribute(#ListIconGadget, #PB_Ignore, #PB_ListIcon_Resizable, Value, 1)
			
		Case #chkColumn2Sortable
			SetGadgetItemAttribute(#ListIconGadget, #PB_Ignore, #PB_ListIcon_Sortable, Value, 1)
			
	EndSelect
	
EndProcedure

OpenWindow(#Desktop, 0, 0, 0, 0, "ListIconGadget-Demo", #PB_Window_Maximize | #PB_Window_BorderLess)

OpenWindow(#Window_0, 0, 0, 900, 440, "ListIconGadget-Demo", #PB_Window_ScreenCentered)

EnableGadgetsAutoBind(@ButtonEvents())

CheckBoxGadget(#chkHeader,          10,  10, 140, 25, "Header")
GadgetToolTip (#chkHeader, "Indicates if header is visible")

CheckBoxGadget(#chkToolbar,         10,  30, 140, 25, "Toolbar")
GadgetToolTip (#chkToolbar, "Indicates if toolbar is visible")

CheckBoxGadget(#chkToolbarReload,   30,  50, 140, 25, "ToolbarReload")
GadgetToolTip (#chkToolbarReload, "Indicates if toolbar reload button is visible")

CheckBoxGadget(#chkToolbarColumns,  30,  70, 140, 25, "ToolbarColumns")
GadgetToolTip (#chkToolbarColumns, "Indicates if toolbar columns button is visible")

CheckBoxGadget(#chkToolbarSearch,   30,  90, 140, 25, "ToolbarSearch")
GadgetToolTip (#chkToolbarSearch, "Indicates if toolbar search controls are visible")

CheckBoxGadget(#chkToolbarAdd,      30, 110, 140, 25, "ToolbarAdd")
GadgetToolTip (#chkToolbarAdd, "Indicates if toolbar add new button is visible")

CheckBoxGadget(#chkToolbarEdit,     30, 130, 140, 25, "ToolbarEdit")
GadgetToolTip (#chkToolbarEdit, "Indicates if toolbar edit button is visible")

CheckBoxGadget(#chkToolbarDelete,   30, 150, 140, 25, "ToolbarDelete")
GadgetToolTip (#chkToolbarDelete, "Indicates if toolbar delete button is visible")

CheckBoxGadget(#chkToolbarSave,     30, 170, 140, 25, "ToolbarSave")
GadgetToolTip (#chkToolbarSave, "Indicates if toolbar save button is visible")

CheckBoxGadget(#chkFooter,          10, 190, 140, 25, "Footer")
GadgetToolTip (#chkFooter, "Indicates if footer is visible")

CheckBoxGadget(#chkColumnHeaders,   10, 210, 140, 25, "ColumnHeaders")
GadgetToolTip (#chkColumnHeaders, "Indicates if columns is visible")

CheckBoxGadget(#chkLineNumbers,     10, 230, 140, 25, "LineNumbers")
GadgetToolTip (#chkLineNumbers, "Indicates if line numbers column is visible")

CheckBoxGadget(#chkExpandColumn,    10, 250, 140, 25, "ExpandColumn")
GadgetToolTip (#chkExpandColumn, "Indicates if expand column is visible")

CheckBoxGadget(#chkSelectColumn,    10, 270, 140, 25, "SelectColumn")
GadgetToolTip (#chkSelectColumn, "Indicates if select column is visible")

CheckBoxGadget(#chkEmptyRecords,    10, 290, 140, 25, "EmptyRecords")
GadgetToolTip (#chkEmptyRecords, "Indicates if empty records are visible")

CheckBoxGadget(#chkSelectionBorder, 10, 310, 140, 25, "SelectionBorder")
GadgetToolTip (#chkSelectionBorder, "Display border arround selection (for selectType = 'cell')")

CheckBoxGadget(#chkRecordTitles,    10, 330, 140, 25, "RecordTitles")
GadgetToolTip (#chkRecordTitles, "Indicates if to define titles for records")

CheckBoxGadget(#chkSkipRecords,     10, 350, 140, 25, "SkipRecords")
GadgetToolTip (#chkSkipRecords, "Indicates if skip records should be visible")

CheckBoxGadget(#chkMultiSelect,     10, 370, 140, 25, "MultiSelect")
GadgetToolTip (#chkMultiSelect, "Indicates if record multi select is allowed")

CheckBoxGadget(#chkHeaderDragDrop,  10, 390, 140, 25, "HeaderDragDrop")
GadgetToolTip (#chkHeaderDragDrop, "Indicates if reordering of columns is allowed")

CheckBoxGadget(#chkSelectTypeCell,  10, 410, 140, 25, "SelectTypeCell")
GadgetToolTip (#chkSelectTypeCell, "Defines selection type cell (default: row)")

CheckBoxGadget(#chkColumn2Resizable, 720, 10, 180, 25, "Make Column 2 resizable")
CheckBoxGadget(#chkColumn2Sortable,  720, 30, 180, 25, "Make Column 2 sortable")
CheckBoxGadget(#chkColumn2Editable,  720, 50, 180, 25, "Make Column 2 editable")

ListIconGadget(#ListIconGadget, 160, 10, 550, 420, "Column 1", @"100%")
AddGadgetColumn(#ListIconGadget, -1, "Column 2", @"100%")
AddGadgetColumn(#ListIconGadget, -1, "Column 3", @"100%")

SetGadgetState(#chkColumnHeaders,    #PB_Checkbox_Checked)
SetGadgetState(#chkEmptyRecords,     #PB_Checkbox_Checked)
SetGadgetState(#chkToolbarAdd,       #PB_Checkbox_Checked)
SetGadgetState(#chkToolbarReload,    #PB_Checkbox_Checked)
SetGadgetState(#chkToolbarColumns,   #PB_Checkbox_Checked)
SetGadgetState(#chkToolbarEdit,      #PB_Checkbox_Checked)
SetGadgetState(#chkToolbarSave,      #PB_Checkbox_Checked)
SetGadgetState(#chkToolbarSearch,    #PB_Checkbox_Checked)
SetGadgetState(#chkToolbarDelete,    #PB_Checkbox_Checked)
SetGadgetState(#chkColumn2Resizable, #PB_Checkbox_Checked)


; fill some sample-data:

Define Counter
Define Items.s = ""

For Counter = 1 To 10
	Items + "Line " + Str(Counter) + " / Col 1" + #LF$ + "Line " + Str(Counter) + " / Col 2" + #LF$ + "Line " + Str(Counter) + " / Col 3"
	If Counter < 10 : Items + #CR$ : EndIf
Next

AddGadgetItem(#ListIconGadget, -1, Items)

SetGadgetAttribute(#ListIconGadget, #PB_ListIcon_HeaderText, @"This is a Header-Text")

Procedure AddEvent()
	Debug "AddEvent()"
EndProcedure

Procedure EditEvent()
	Debug "EditEvent()"
EndProcedure

Procedure DeleteEvent()
	Debug "DeleteEvent()"
EndProcedure

!w2ui["g_" + ListIconGadget].on('add', function (event) { AddEvent(); });
!w2ui["g_" + ListIconGadget].on('edit', function (event) { EditEvent(); });

!w2ui["g_" + ListIconGadget].on('delete', function (event) { 
! event.force = true; 
! event.preventDefault(); 
! DeleteEvent(); 
!});

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 2
; FirstLine = 200
; Folding = --
; EnableXP