XIncludeFile "..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

; ----

Debug "--- Example: Simple Map ---"

NewMap Country.s()

Country("GE") = "Germany"
Country("FR") = "France"
Country("UK") = "United Kingdom"

Debug Country("FR")

Debug "MapKey: " + MapKey(Country())

ForEach Country()
	Debug Country()
Next

Debug "MapKey: " + MapKey(Country())

; ----

; Debug "--- Map as Procedure parameter ---"
; 
; NewMap Country.s()
; 
; Country("GE") = "Germany"
; Country("FR") = "France"
; Country("UK") = "United Kingdom"
; 
; Procedure DebugMap(Map ParameterMap.s())
; 	
; 	ParameterMap("US") = "United States"
; 	
; 	ForEach ParameterMap()
; 		Debug ParameterMap()
; 	Next
; 	
; EndProcedure
; 
; DebugMap(Country())

; ----

Debug "--- Example: Structured Map ---"

Structure Car
	Weight.l
	Speed.l
	Price.l
EndStructure

NewMap Cars.Car()

; Here we use the current element after the new insertion
;
Cars("Ferrari F40")\Weight = 1000
Cars()\Speed = 320
Cars()\Price = 500000

Cars("Lamborghini Gallardo")\Weight = 1200
Cars()\Speed = 340
Cars()\Price = 700000

ForEach Cars()
	Debug "Car name: "+MapKey(Cars())
	Debug "Weight: "+Str(Cars()\Weight)
Next

Debug "--- Example: CopyMap() ---"

NewMap Age()
NewMap AgeCopy()

Age("John") = 15
Age("Elise") = 30

If CopyMap(Age(), AgeCopy())
	
	Debug "MapSize(Age()): " + Str(MapSize(Age()))
	Debug "MapSize(AgeCopy()): " + Str(MapSize(AgeCopy()))
	
	Debug "John: " + Str(AgeCopy("John"))
	Debug "Elise: " + Str(AgeCopy("Elise"))
	
EndIf

Debug "--- Example: DeleteMapElement() ---"

NewMap Country.s()

Country("US") = "United States"
Country("FR") = "France"
Country("GE") = "Germany"

; Delete a country
DeleteMapElement(Country(), "FR")

ForEach Country()
	Debug Country()
Next

Debug "--- Example: FindMapElement() ---"

NewMap Country.s()

Country("US") = "United States"
Country("FR") = "France"
Country("GE") = "Germany"

If FindMapElement(Country(), "US")
	Debug "'US' is in the country list."    
Else
	Debug "'US' is NOT in the country list!"    
EndIf

If FindMapElement(Country(), "UK")
	Debug "'UK' is in the country list."
Else
	Debug "'UK' is NOT in the country list!"
EndIf



; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 65
; FirstLine = 36
; Folding = -
; EnableXP