XIncludeFile "..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

Enumeration
	#WebGadget
	#cboSelect
EndEnumeration

; all demos taken from http://parall.ax/products/jspdf

Global imgData.s

Procedure Images()
	
	Protected doc = NewPDF()
	PdfSetFontSize(doc, 40)
	PdfAddText(doc, 35, 25, "PB2Web loves jsPDF")
	PdfAddImage(doc, imgData, "JPEG", 15, 40, 190, 114)	
	Protected PdfOutput.s = PdfOutput(doc)
	SetGadgetText(#WebGadget, PdfOutput)
	
EndProcedure

Procedure Fontfaces()
	
	Protected doc = NewPDF()
	
	PdfAddText(doc, 20, 20, "This is the default font.")
	
	PdfSetFont(doc, "courier")
	PdfSetFontType(doc, "normal")
	PdfAddText(doc, 20, 30, "This is courier normal.")
	
	PdfSetFont(doc, "times")
	PdfSetFontType(doc, "italic")
	PdfAddText(doc, 20, 40, "This is times italic.")
	
	PdfSetFont(doc, "helvetica")
	PdfSetFontType(doc, "bold")
	PdfAddText(doc, 20, 50, "This is helvetica bold.")
	
	PdfSetFont(doc, "courier")
	PdfSetFontType(doc, "bolditalic")
	PdfAddText(doc, 20, 60, "This is courier bolditalic.")
	
	Protected PdfOutput.s = PdfOutput(doc)
	SetGadgetText(#WebGadget, PdfOutput)	
	
EndProcedure

Procedure TwoPageHelloWorld()
	
	Protected doc = NewPDF()
	
	PdfAddText(doc, 20, 20, "Hello world!")
	PdfAddText(doc, 20, 30, "This is client-side Javascript, pumping out a PDF.")
	PdfAddPage(doc)
	PdfAddText(doc, 20, 20, "Do you like that?")
	
	Protected PdfOutput.s = PdfOutput(doc)
	SetGadgetText(#WebGadget, PdfOutput)	
	
EndProcedure

Procedure Circles()
	
	Protected doc = NewPDF()
	
	PdfAddEllipse(doc, 40, 20, 10, 5)
	
	PdfSetFillColor(doc, 0, 0, 255)
	PdfAddEllipse(doc, 80, 20, 10, 5, "F")
	
	PdfSetLineWidth(doc, 1)
	PdfSetDrawColor(doc, 0, 0, 0)
	PdfSetFillColor(doc, 255, 0, 0)
	PdfAddCircle(doc, 120, 20, 5, "FD")
	
	Protected PdfOutput.s = PdfOutput(doc)
	SetGadgetText(#WebGadget, PdfOutput)
	
EndProcedure

Procedure FontSizes()
	
	Protected doc = NewPDF()
	
	PdfSetFontSize(doc, 22)
	PdfAddText(doc, 20, 20, "This is a title")
	
	PdfSetFontSize(doc, 16)
	PdfAddText(doc, 20, 30, "This is some normal sized text underneath.")
	
	Protected PdfOutput.s = PdfOutput(doc)
	SetGadgetText(#WebGadget, PdfOutput)
	
EndProcedure

Procedure LandScape()
	
	Protected doc = NewPDF("landscape")
	
	PdfAddText(doc, 20, 20, "Hello landscape world!")
	
	Protected PdfOutput.s = PdfOutput(doc)
	SetGadgetText(#WebGadget, PdfOutput)
	
EndProcedure

Procedure Lines()
	
	Protected doc = NewPDF()
	
	PdfAddLine(doc, 20, 20, 60, 20) ; // horizontal line
	
	PdfSetLineWidth(doc, 0.5)
	PdfAddLine(doc, 20, 25, 60, 25)
	
	PdfSetLineWidth(doc, 1)
	PdfAddLine(doc, 20, 30, 60, 30)
	
	PdfSetLineWidth(doc, 1.5)
	PdfAddLine(doc, 20, 35, 60, 35)
	
	PdfSetDrawColor(doc, 255, 0, 0) ; // draw red lines
	
	PdfSetLineWidth(doc, 0.1)
	PdfAddLine(doc, 100, 20, 100, 60) ; // vertical line
	
	PdfSetLineWidth(doc, 0.5)
	PdfAddLine(doc, 105, 20, 105, 60)
	
	PdfSetLineWidth(doc, 1)
	PdfAddLine(doc, 110, 20, 110, 60)
	
	PdfSetLineWidth(doc, 1.5)
	PdfAddLine(doc, 115, 20, 115, 60)
	
	Protected PdfOutput.s = PdfOutput(doc)
	SetGadgetText(#WebGadget, PdfOutput)
	
EndProcedure

Procedure Rectangles()
	
	Protected doc = NewPDF()
	
	; Empty square
	PdfAddRect(doc, 20, 20, 10, 10)
	
	; Filled square
	PdfAddRect(doc, 40, 20, 10, 10, "F")
	
	; Empty red square
	PdfSetDrawColor(doc, 255, 0, 0)
	PdfAddRect(doc, 60, 20, 10, 10)
	
	; Filled square With red borders
	PdfSetDrawColor(doc, 255, 0, 0)
	PdfAddRect(doc, 80, 20, 10, 10, "FD")
	
	; Filled red square
	PdfSetDrawColor(doc, 0, 0, 0)
	PdfSetFillColor(doc, 255, 0, 0)
	PdfAddRect(doc, 100, 20, 10, 10, "F")
	
	; Filled red square With black borders
	PdfSetDrawColor(doc, 0, 0, 0)
	PdfSetFillColor(doc, 255, 0, 0)
	PdfAddRect(doc, 120, 20, 10, 10, "FD")
	
	; Black sqaure With rounded corners
	PdfSetDrawColor(doc, 0, 0, 0)
	PdfSetFillColor(doc, 255, 255, 255)
	PdfAddRoundedRect(doc, 140, 20, 10, 10, 3, 3, "FD")
	
	Protected PdfOutput.s = PdfOutput(doc)
	SetGadgetText(#WebGadget, PdfOutput)
	
EndProcedure

Procedure TextColors()
	
	Protected doc = NewPDF()
	
	; I know the proper spelling is colour ;)
	PdfSetTextColor(doc, 100, 100, 100)
	PdfAddText(doc, 20, 20, "This is gray.")
	
	PdfSetTextColor(doc, 150, 150, 150)
	PdfAddText(doc, 20, 30, "This is light gray.")
	
	PdfSetTextColor(doc, 255, 0, 0)
	PdfAddText(doc, 20, 40, "This is red.")
	
	PdfSetTextColor(doc, 0, 255, 0)
	PdfAddText(doc, 20, 50, "This is green.")
	
	PdfSetTextColor(doc, 0, 0, 255)
	PdfAddText(doc, 20, 60, "This is blue.")
	
	Protected PdfOutput.s = PdfOutput(doc)
	SetGadgetText(#WebGadget, PdfOutput)
	
EndProcedure

Procedure Triangles()
	
	Protected doc = NewPDF()
	
	PdfAddTriangle(doc, 60, 100, 60, 120, 80, 110, "FD")
	
	PdfSetLineWidth(doc, 1)
	PdfSetDrawColor(doc, 255, 0, 0)
	PdfSetFillColor(doc, 0, 0, 255)
	PdfAddTriangle(doc, 100, 100, 110, 100, 120, 130, "FD")
	
	Protected PdfOutput.s = PdfOutput(doc)
	SetGadgetText(#WebGadget, PdfOutput)
	
EndProcedure

Procedure P2W_Image2DataURL_Success(ImageData.s)
	imgData = ImageData
	DisableGadget(#cboSelect, #False)
EndProcedure

Procedure P2W_Image2DataURL_Error(Error.s)
	P2W_Alert(Error)
EndProcedure

Procedure cboSelect_Event()
	
	Select GetGadgetText(#cboSelect)
			
		Case "Images"
			Images()
			
		Case "Font faces"
			Fontfaces()
			
		Case "HTML Renderer (Early stages)"
			; not implemented (yet)
			
		Case "Two page Hello World"
			TwoPageHelloWorld()
			
		Case "Circles"
			Circles()
			
		Case "Font sizes"
			FontSizes()
			
		Case "Landscape"
			LandScape()
			
		Case "Lines"
			Lines()
			
		Case "Rectangles"
			Rectangles()
			
		Case "String Splitting"
			; not implemented (yet)
			
		Case "Text colors"
			TextColors()
			
		Case "Triangles"			
			Triangles()
			
	EndSelect
	
EndProcedure	

WebGadget(#WebGadget, 350, 10, 400, 400, "")

ComboBoxGadget(#cboSelect, 10, 10, 300, 22)

AddGadgetItem(#cboSelect, -1, "Select a demo...")
AddGadgetItem(#cboSelect, -1, "Images")
AddGadgetItem(#cboSelect, -1, "Font faces")
; AddGadgetItem(#cboSelect, -1, "HTML Renderer (Early stages)") ; not implemented (yet)
AddGadgetItem(#cboSelect, -1, "Two page Hello World")
AddGadgetItem(#cboSelect, -1, "Circles")
AddGadgetItem(#cboSelect, -1, "Font sizes")
AddGadgetItem(#cboSelect, -1, "Landscape")
AddGadgetItem(#cboSelect, -1, "Lines")
AddGadgetItem(#cboSelect, -1, "Rectangles")
; AddGadgetItem(#cboSelect, -1, "String Splitting") ; not implemented (yet)
AddGadgetItem(#cboSelect, -1, "Text colors")
AddGadgetItem(#cboSelect, -1, "Triangles")

SetGadgetState(#cboSelect, 0)

BindGadgetEvent(#cboSelect, @cboSelect_Event(), #PB_EventType_Change)

DisableGadget(#cboSelect, #True)

P2W_Image2DataURL("logo.png", @P2W_Image2DataURL_Success(), @P2W_Image2DataURL_Error())

DataSection
	IncludeBinary "logo.png"
EndDataSection

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 223
; FirstLine = 23
; Folding = BA+
; EnableUnicode
; EnableXP