EnableExplicit

XIncludeFile "..\..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

Enumeration
	#TextGadget
	#StringGadgetArray
	#StringGadgetString
	#StringGadgetFunction
	#ButtonOpen
	#ButtonClose
EndEnumeration

EnableCGI

ProcedureDLL.s AutocompleteFunctionServer(RequestTerm.s)
	
	Protected Counter
	Protected Datasource.s = "Bruce Wayne;Clark Kent;Peter Parker"
	Protected ReturnValue.s = ""
	
	For Counter = 1 To CountString(Datasource, ";") + 1
		If FindString(StringField(Datasource, Counter, ";"), RequestTerm, 1, #PB_String_NoCase)
			ReturnValue + StringField(Datasource, Counter, ";") + ";"
		EndIf
	Next
	
	ReturnValue = Left(ReturnValue, Len(ReturnValue) - 1)
	
	ProcedureReturn ReturnValue
	
EndProcedure

DisableCGI

Procedure AutocompleteFunctionClient(request, response)
	
	Protected RequestTerm.s
	
	! RequestTerm = request.term;
	
	Protected ReturnValue.s
	
	ReturnValue = AutocompleteFunctionServer(RequestTerm)
	
	Protected Counter
	
	Dim ResultArray.s(0)
	ResultArray(0) = "no results..."
	
	For Counter = 1 To CountString(ReturnValue, ";") + 1
		ResultArray(Counter - 1) = StringField(ReturnValue, Counter, ";")
	Next
	
	! response( ResultArray );
	
EndProcedure

Procedure AutocompleteOpen()
	! $("#g_" + StringGadgetArray).autocomplete( "search", "" );
EndProcedure

Procedure AutocompleteClose()
	! $("#g_" + StringGadgetArray).autocomplete( "close" );
EndProcedure

; ----

TextGadget(#PB_Any, 10, 10, 280, 20, "Autocomplete with Datasource = Array")
StringGadget(#StringGadgetArray, 10, 30, 280, 25, "")

Dim AutocompleteArray.s(0)

AutocompleteArray(0) = "Bruce Wayne"
AutocompleteArray(1) = "Clark Kent"
AutocompleteArray(2) = "Peter Parker"

SetGadgetAttribute(#StringGadgetArray, #PB_String_Placeholder, @"Try to type 'c' or 'r'...")
SetGadgetAttribute(#StringGadgetArray, #PB_String_Autocomplete_MinLength, 0)
SetGadgetAttribute(#StringGadgetArray, #PB_String_Autocomplete_Datasource, @AutocompleteArray())

BindGadgetEvent(#StringGadgetArray, @AutocompleteOpen(), #PB_EventType_Focus)

; ----

TextGadget(#PB_Any, 10, 70, 280, 20, "Autocomplete with Datasource = URL")
StringGadget(#StringGadgetString, 10, 90, 280, 25, "")
SetGadgetAttribute(#StringGadgetString, #PB_String_Placeholder, @"Try to type 'c' or 'r'...")
Define AutocompleteUrl.s = "data.json"
SetGadgetAttribute(#StringGadgetString, #PB_String_Autocomplete_Datasource, @AutocompleteUrl)

; ----

TextGadget(#PB_Any, 10, 130, 280, 20, "Autocomplete with Datasource = Function")
StringGadget(#StringGadgetFunction, 10, 150, 280, 25, "")
SetGadgetAttribute(#StringGadgetFunction, #PB_String_Placeholder, @"Try to type 'c' or 'r'...")
SetGadgetAttribute(#StringGadgetFunction, #PB_String_Autocomplete_MinLength, 0)
SetGadgetAttribute(#StringGadgetFunction, #PB_String_Autocomplete_Datasource, @AutocompleteFunctionClient())

; ----

ButtonGadget(#ButtonOpen, 300, 30, 160, 25, "Open Autocomplete")
BindGadgetEvent(#ButtonOpen, @AutocompleteOpen(), #PB_EventType_LeftClick)

ButtonGadget(#ButtonClose, 470, 30, 160, 25, "Close Autocomplete")
BindGadgetEvent(#ButtonClose, @AutocompleteClose(), #PB_EventType_LeftClick)


DataSection
	IncludeBinary "data.json"
EndDataSection

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 59
; Folding = h
; EnableXP