EnableExplicit

XIncludeFile "..\..\..\p2w.pbi"
XIncludeFile "..\..\..\UserGadgets\GoogleChartGadget\GoogleChartGadget.pbi"

P2W_Converter_SetProfile("pb2webtest")

Enumeration
	#frmMain
	#PanelGadget
	#myTimer
	#LineChart
	#BarChart
	#PieChart
	#GeoChart
	#ScatterChart
	#Gauge
EndEnumeration

Declare TimerEvent()

Procedure DrawLineChart()
	
	; #################
	; # LineChart
	; #################
	
	; https://google-developers.appspot.com/chart/interactive/docs/gallery/linechart
	
	Protected myData.s
	Protected myOptions.s
	
	; Set options
	
	myOptions = "{'title':'Company Performance'}"
	
	myOptions = ReplaceString(myOptions, "'", Chr(34))
	
	; Set Data
	
	myData = "[" + 
	         "['Year', 'Sales', 'Expenses']," + 
	         "['2004',    1000,        400]," + 
	         "['2005',    1170,        460]," + 
	         "['2006',     660,       1120]," + 
	         "['2007',    1030,        540]" + 
	         "]"
	
	myData = ReplaceString(myData, "'", Chr(34))
	
	; Draw Chart
	
	GoogleChartGadgetDraw(#LineChart, myData, myOptions)
	
EndProcedure

Procedure DrawBarChart()
	
	; #################
	; # BarChart
	; #################
	
	; https://developers.google.com/chart/interactive/docs/gallery/barchart
	
	Protected myData.s
	Protected myOptions.s
	
	; Set options
	
	myOptions = "{'title':'Company Performance'}"
	
	myOptions = ReplaceString(myOptions, "'", Chr(34))
	
	; Set Data
	
	myData = "[" + 
	         "['Year', 'Sales', 'Expenses']," + 
	         "['2004',    1000,        400]," + 
	         "['2005',    1170,        460]," + 
	         "['2006',     660,       1120]," + 
	         "['2007',    1030,        540]" + 
	         "]"
	
	myData = ReplaceString(myData, "'", Chr(34))
	
	; Draw Chart
	
	GoogleChartGadgetDraw(#BarChart, myData, myOptions)
	
EndProcedure

Procedure DrawPieChart()
	
	; #################
	; # PieChart
	; #################
	
	; https://google-developers.appspot.com/chart/interactive/docs/gallery/piechart
	
	Protected myData.s
	Protected myOptions.s
	
	; Set Pptions 
	
	myOptions = "{'title':'How Much Pizza I Ate Last Night', 'pieHole':'0.4'}"
	
	myOptions = ReplaceString(myOptions, "'", Chr(34))
	
	; Set Data
	
	myData = "[" + 
	         "['Topping', 'Slices']," + 
	         "['Mushrooms', 3]," + 
	         "['Onions',    1]," + 
	         "['Olives',    1]," + 
	         "['Zucchini',  1]," + 
	         "['Pepperoni', 2]" + 
	         "]"
	
	myData = ReplaceString(myData, "'", Chr(34))
	
	; Draw Chart
	
	GoogleChartGadgetDraw(#PieChart, myData, myOptions)
	
EndProcedure

Procedure DrawGeoChart()
	
	; #################
	; # GeoChart
	; #################
	
	; https://google-developers.appspot.com/chart/interactive/docs/gallery/geochart
	
	Protected myData.s
	
	; Set Data
	
	myData = "[" + 
	         "['Country', 'Popularity']," + 
	         "['Germany',          200]," + 
	         "['United States',    300]," + 
	         "['Brazil',           400]," + 
	         "['Canada',           500]," + 
	         "['France',           600]," + 
	         "['RU',               700]"  + 
	         "]"
	
	myData = ReplaceString(myData, "'", Chr(34))
	
	; Draw Chart
	
	GoogleChartGadgetDraw(#GeoChart, myData)
	
EndProcedure

Procedure DrawScatterChart()
	
	; #################
	; # ScatterChart
	; #################
	
	; https://google-developers.appspot.com/chart/interactive/docs/gallery/scatterchart
	
	Protected myData.s
	Protected myOptions.s
	
	; Set Options
	
	myOptions = "{" + 
	            " 'title': 'Age vs. Weight comparison', " + 
	            " 'hAxis': {'title': 'Age', 'minValue': 0, 'maxValue': 15}, " + 
	            " 'vAxis': {'title': 'Weight', 'minValue': 0, 'maxValue': 15}, " + 
	            " 'legend': 'none' " +
							"}"
	
	myOptions = ReplaceString(myOptions, "'", Chr(34))

	; Set Data
	
	myData = "[" + 
	         "['Age', 'Weight']," + 
	         "[8,           12]," + 
	         "[4,          5.5]," + 
	         "[11,          14]," + 
	         "[4,            5]," + 
	         "[3,          3.5]," + 
	         "[6.5,          7]"  + 
	         "]"
	
	myData = ReplaceString(myData, "'", Chr(34))
	
	; Draw Chart
	
	GoogleChartGadgetDraw(#ScatterChart, myData, myOptions)
	
EndProcedure

Procedure DrawGauge()
	
	; #################
	; # Gauge
	; #################
	
	; https://google-developers.appspot.com/chart/interactive/docs/gallery/gauge
	
	Protected myOptions.s
	Protected myData.s
	
	; Set Options
	
	myOptions = "{'redFrom':90,'redTo':100,'yellowFrom':75,'yellowTo':90,'minorTicks':5}"
	
	myOptions = ReplaceString(myOptions, "'", Chr(34))
	
	; Set Data
	
	myData = "[" + 
	         "['Label', 'Value']," + 
	         "['Memory',     80]," + 
	         "['CPU',        55]," + 
	         "['Network',    68]" +
	         "]"
	
	myData = ReplaceString(myData, "'", Chr(34))
	
	; Draw Chart
	
	GoogleChartGadgetDraw(#Gauge, myData, myOptions)
	
	; Set a timer for updating Gauge-Values
	
	AddWindowTimer(#frmMain, #myTimer, 1000)
	
	BindEvent(#PB_Event_Timer, @TimerEvent(), #frmMain, #myTimer)
	
EndProcedure

Procedure TimerEvent()
	
	Protected myData.s
	
	myData = "[" + 
	         "['Label',                       'Value']," + 
	         "['Memory',  " + Str(Random(100, 0)) + "]," + 
	         "['CPU',     " + Str(Random(100, 0)) + "]," + 
	         "['Network', " + Str(Random(100, 0)) + "]" +
	         "]"
	
	myData = ReplaceString(myData, "'", Chr(34))
	
	GoogleChartGadgetDraw(#Gauge, myData)
	
EndProcedure

Procedure PanelGadgetEvent()
	
	If IsWindowTimer(#frmMain, #myTimer)
		RemoveWindowTimer(#frmMain, #myTimer)
	EndIf
	
	Select GetGadgetState(#PanelGadget)
		Case 0 ; LineChart
			DrawLineChart()
		Case 1 ; BarChart
			DrawBarChart()
		Case 2 ; PieChart
			DrawPieChart()
		Case 3 ; GeoChart
			DrawGeoChart()
		Case 4 ; ScatterChart
			DrawScatterChart()
		Case 5 ; Gauge
			DrawGauge()
	EndSelect
	
EndProcedure

Procedure Main()
	
	OpenWindow(#frmMain, #PB_Ignore, #PB_Ignore, 720, 530, "GoogleChart", #PB_Window_ScreenCentered)
	
	PanelGadget(#PanelGadget, 10, 10, 700, 500)
	
	AddGadgetItem(#PanelGadget, -1, "LineChart")
	GoogleChartGadget(#LineChart, 10, 20, 670, 440, "LineChart", #PB_GoogleChart_Border)
	
	AddGadgetItem(#PanelGadget, -1, "BarChart")
	GoogleChartGadget(#BarChart, 10, 20, 670, 440, "BarChart", #PB_GoogleChart_Border)
	
	AddGadgetItem(#PanelGadget, -1, "PieChart")
	GoogleChartGadget(#PieChart, 10, 20, 670, 440, "PieChart", #PB_GoogleChart_Border)
	
	AddGadgetItem(#PanelGadget, -1, "GeoChart")
	GoogleChartGadget(#GeoChart, 10, 20, 670, 440, "GeoChart", #PB_GoogleChart_Border)
	
	AddGadgetItem(#PanelGadget, -1, "ScatterChart")
	GoogleChartGadget(#ScatterChart, 10, 20, 670, 440, "ScatterChart", #PB_GoogleChart_Border)
	
	AddGadgetItem(#PanelGadget, -1, "Gauge")
	GoogleChartGadget(#Gauge, 10, 20, 670, 440, "Gauge", #PB_GoogleChart_Border)
	
	CloseGadgetList()
	
	BindGadgetEvent(#PanelGadget, @PanelGadgetEvent())
	
	SetGadgetState(#PanelGadget, 0)
	
	PanelGadgetEvent()
	
EndProcedure

Main()

; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 259
; FirstLine = 4
; Folding = A1
; EnableXP