EnableExplicit

XIncludeFile "..\..\..\p2w.pbi"
XIncludeFile "..\..\..\UserGadgets\GoogleMapGadget\GoogleMapGadget.pbi"

#myWindow    = 0
#myGoogleMap = 0

P2W_Converter_SetProfile("pb2webtest")

Procedure GoogleMapEvent(lat, lng)
	
	Debug "Map-Event"
	
	Select EventType()
		Case #PB_EventType_GoogleMap_BoundsChanged     : Debug "#PB_EventType_GoogleMap_BoundsChanged"
		Case #PB_EventType_GoogleMap_CenterChanged     : Debug "#PB_EventType_GoogleMap_CenterChanged"
		Case #PB_EventType_GoogleMap_Click             : Debug "#PB_EventType_GoogleMap_Click"
		Case #PB_EventType_GoogleMap_DblClick          : Debug "#PB_EventType_GoogleMap_DblClick"
		Case #PB_EventType_GoogleMap_Drag              : Debug "#PB_EventType_GoogleMap_Drag"
		Case #PB_EventType_GoogleMap_DragEnd           : Debug "#PB_EventType_GoogleMap_DragEnd"
		Case #PB_EventType_GoogleMap_DragStart         : Debug "#PB_EventType_GoogleMap_DragStart"
		Case #PB_EventType_GoogleMap_HeadingChanged    : Debug "#PB_EventType_GoogleMap_HeadingChanged"
		Case #PB_EventType_GoogleMap_Idle              : Debug "#PB_EventType_GoogleMap_Idle"
		Case #PB_EventType_GoogleMap_MapTypeIdChanged  : Debug "#PB_EventType_GoogleMap_MapTypeIdChanged"
		Case #PB_EventType_GoogleMap_MouseMove         : Debug "#PB_EventType_GoogleMap_MouseMove"
		Case #PB_EventType_GoogleMap_MouseOut          : Debug "#PB_EventType_GoogleMap_MouseOut"
		Case #PB_EventType_GoogleMap_MouseOver         : Debug "#PB_EventType_GoogleMap_MouseOver"
		Case #PB_EventType_GoogleMap_ProjectionChanged : Debug "#PB_EventType_GoogleMap_ProjectionChanged"	
		Case #PB_EventType_GoogleMap_Resize            : Debug "#PB_EventType_GoogleMap_Resize"
		Case #PB_EventType_GoogleMap_RightClick        : Debug "#PB_EventType_GoogleMap_RightClick"
		Case #PB_EventType_GoogleMap_TilesLoaded       : Debug "#PB_EventType_GoogleMap_TilesLoaded"
		Case #PB_EventType_GoogleMap_TiltChanged       : Debug "#PB_EventType_GoogleMap_TiltChanged"
		Case #PB_EventType_GoogleMap_ZoomChanged       : Debug "#PB_EventType_GoogleMap_ZoomChanged"
		Default                                        : Debug "??? unknown event ???"
	EndSelect
	
	Debug "lat: " + Str(lat)
	Debug "lng: " + Str(lng)
	Debug "----"
	
EndProcedure

Procedure GoogleMapMarkerEvent(Item, lat, lng)
	
	Debug "Marker-Event: Item " + Str(Item)
	
	Select EventType()
		Case #PB_EventType_GoogleMapMarker_AnimationChanged : Debug "#PB_EventType_GoogleMapMarker_AnimationChanged"
		Case #PB_EventType_GoogleMapMarker_Click            : Debug "#PB_EventType_GoogleMapMarker_Click"
		Case #PB_EventType_GoogleMapMarker_ClickableChanged : Debug "#PB_EventType_GoogleMapMarker_ClickableChanged"
		Case #PB_EventType_GoogleMapMarker_CursorChanged    : Debug "#PB_EventType_GoogleMapMarker_CursorChanged"
		Case #PB_EventType_GoogleMapMarker_DblClick         : Debug "#PB_EventType_GoogleMapMarker_DblClick"
		Case #PB_EventType_GoogleMapMarker_Drag             : Debug "#PB_EventType_GoogleMapMarker_Drag"
		Case #PB_EventType_GoogleMapMarker_DragEnd          : Debug "#PB_EventType_GoogleMapMarker_DragEnd"
		Case #PB_EventType_GoogleMapMarker_DraggableChanged : Debug "#PB_EventType_GoogleMapMarker_DraggableChanged"
		Case #PB_EventType_GoogleMapMarker_DragStart        : Debug "#PB_EventType_GoogleMapMarker_DragStart"
		Case #PB_EventType_GoogleMapMarker_FlatChanged      : Debug "#PB_EventType_GoogleMapMarker_FlatChanged"
		Case #PB_EventType_GoogleMapMarker_IconChanged      : Debug "#PB_EventType_GoogleMapMarker_IconChanged"
		Case #PB_EventType_GoogleMapMarker_MouseDown        : Debug "#PB_EventType_GoogleMapMarker_MouseDown"
		Case #PB_EventType_GoogleMapMarker_MouseOut         : Debug "#PB_EventType_GoogleMapMarker_MouseOut"
		Case #PB_EventType_GoogleMapMarker_MouseOver        : Debug "#PB_EventType_GoogleMapMarker_MouseOver"
		Case #PB_EventType_GoogleMapMarker_MouseUp          : Debug "#PB_EventType_GoogleMapMarker_MouseUp"
		Case #PB_EventType_GoogleMapMarker_PositionChanged  : Debug "#PB_EventType_GoogleMapMarker_PositionChanged"
		Case #PB_EventType_GoogleMapMarker_RightClick       : Debug "#PB_EventType_GoogleMapMarker_RightClick"
		Case #PB_EventType_GoogleMapMarker_ShapeChanged     : Debug "#PB_EventType_GoogleMapMarker_ShapeChanged"
		Case #PB_EventType_GoogleMapMarker_TitleChanged     : Debug "#PB_EventType_GoogleMapMarker_TitleChanged"
		Case #PB_EventType_GoogleMapMarker_VisibleChanged   : Debug "#PB_EventType_GoogleMapMarker_VisibleChanged"
		Case #PB_EventType_GoogleMapMarker_ZIndexChanged    : Debug "#PB_EventType_GoogleMapMarker_ZIndexChanged"			
		Default                                             : Debug "??? unknown event ???"
	EndSelect
	
	Debug "lat: " + Str(lat)
	Debug "lng: " + Str(lng)
	Debug "----"
	
EndProcedure

Procedure BindGoogleMapEvents()
	
	; -----------------
	; GoogleMap - Events:
	; -----------------
	
	; bounds_changed	None	This event is fired when the viewport bounds have changed.
	BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_BoundsChanged)
	
	; center_changed	None	This event is fired when the map center property changes.
	BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_CenterChanged)
	
	; click	MouseEvent	This event is fired when the user clicks on the map (but not when they click on a marker or infowindow).
	BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_Click)
	
	; dblclick	MouseEvent	This event is fired when the user double-clicks on the map. Note that the click event will also fire, right before this one.
	BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_DblClick)
	
	; drag	None	This event is repeatedly fired while the user drags the map.
	BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_Drag)
	
	; dragend	None	This event is fired when the user stops dragging the map.
	BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_DragEnd)
	
	; dragstart	None	This event is fired when the user starts dragging the map.
	BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_DragStart)
	
	; heading_changed	None	This event is fired when the map heading property changes.
	BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_HeadingChanged)
	
	; idle	None	This event is fired when the map becomes idle after panning or zooming.
	BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_Idle)
	
	; maptypeid_changed	None	This event is fired when the mapTypeId property changes.
	BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_MapTypeIdChanged)
	
	; mousemove	MouseEvent	This event is fired whenever the user's mouse moves over the map container.
	; BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_MouseMove)
	
	; mouseout	MouseEvent	This event is fired when the user's mouse exits the map container.
	; BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_MouseOut)
	
	; mouseover	MouseEvent	This event is fired when the user's mouse enters the map container.
	; BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_MouseOver)
	
	; projection_changed	None	This event is fired when the projection has changed.
	BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_ProjectionChanged)
	
	; resize	None	Developers should trigger this event on the map when the div changes size
	BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_Resize)
	
	; rightclick	MouseEvent	This event is fired when the DOM contextmenu event is fired on the map container.
	BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_RightClick)
	
	; tilesloaded	None	This event is fired when the visible tiles have finished loading.
	BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_TilesLoaded)
	
	; tilt_changed	None	This event is fired when the map tilt property changes.
	BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_TiltChanged)
	
	; zoom_changed	None	This event is fired when the map zoom property changes.
	BindGadgetEvent(#myGoogleMap, @GoogleMapEvent(), #PB_EventType_GoogleMap_ZoomChanged)
	
EndProcedure

Procedure BindGoogleMapMarkerEvents()
	
	; -----------------
	; GoogleMapMarker - Events:
	; -----------------
	
	; animation_changed	None	This event is fired when the marker's animation property changes.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_AnimationChanged)
	
	; click	MouseEvent	This event is fired when the marker icon was clicked.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_Click)
	
	; clickable_changed	None	This event is fired when the marker's clickable property changes.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_ClickableChanged)
	
	; cursor_changed	None	This event is fired when the marker's cursor property changes.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_CursorChanged)
	
	; dblclick	MouseEvent	This event is fired when the marker icon was double clicked.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_DblClick)
	
	; drag	MouseEvent	This event is repeatedly fired while the user drags the marker.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_Drag)
	
	; dragend	MouseEvent	This event is fired when the user stops dragging the marker.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_DragEnd)
	
	; draggable_changed	None	This event is fired when the marker's draggable property changes.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_DraggableChanged)
	
	; dragstart	MouseEvent	This event is fired when the user starts dragging the marker.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_DragStart)
	
	; flat_changed	None	This event is fired when the marker's flat property changes.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_FlatChanged)
	
	; icon_changed	None	This event is fired when the marker icon property changes.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_IconChanged)
	
	; mousedown	MouseEvent	This event is fired for a mousedown on the marker.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_MouseDown)
	
	; mouseout	MouseEvent	This event is fired when the mouse leaves the area of the marker icon.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_MouseOut)
	
	; mouseover	MouseEvent	This event is fired when the mouse enters the area of the marker icon.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_MouseOver)
	
	; mouseup	MouseEvent	This event is fired for a mouseup on the marker.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_MouseUp)
	
	; position_changed	None	This event is fired when the marker position property changes.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_PositionChanged)
	
	; rightclick	MouseEvent	This event is fired for a rightclick on the marker.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_RightClick)
	
	; shape_changed	None	This event is fired when the marker's shape property changes.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_ShapeChanged)
	
	; title_changed	None	This event is fired when the marker title property changes.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_TitleChanged)
	
	; visible_changed	None	This event is fired when the marker's visible property changes.
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_VisibleChanged)
	
	; zindex_changed	None	This event is fired when the marker's zIndex property changes.	
	BindGadgetItemEvent(#myGoogleMap, 0, @GoogleMapMarkerEvent(), #PB_EventType_GoogleMapMarker_ZIndexChanged)
	
EndProcedure

Procedure GoogleMapsGeocoder2Success(ResultCsv.s)
	
	Protected Address.s = StringField(ResultCsv, 1, ";")
	Protected LatLng.s  = StringField(ResultCsv, 2, ";")
	
	LatLng = RemoveString(LatLng, "(")
	LatLng = RemoveString(LatLng, ")")
	
	Protected GoogleMap
	
	OpenWindow(#myWindow, 10, 10, 660, 500, "GoogleMapTest")
	
	; ------
	
	GoogleMapGadget(#myGoogleMap, 10, 10, 640, 480)
	
	SetGadgetAttribute(#myGoogleMap, #GoogleMapType, #GoogleMapTypeSatellite)
	SetGadgetAttribute(#myGoogleMap, #GoogleMapZoom, 18)
	
	AddGadgetItem(#myGoogleMap, -1, LatLng, LoadImage(#PB_Any, "case.png"))
		
 	SetGadgetItemText(#myGoogleMap, 0, Address)
 	
 	SetGadgetItemText(#myGoogleMap, 0, "Ich hab' noch einen Koffer in Berlin", #GoogleMapInfoWindow | #GoogleMapInfoWindowAutoOpen)
	
	; SetGadgetItemImage(#myGoogleMap, 0, LoadImage(#PB_Any, "case.png"))

 	SetGadgetItemAttribute(#myGoogleMap, 0, #GoogleMapMarkerDraggable, #True)
 	
 	; Debug GetGadgetItemAttribute(#myGoogleMap, 0, #GoogleMapMarkerPosition)
 	
	; SetGadgetItemAttribute(#myGoogleMap, 0, #GoogleMapMarkerPosition, @"51.5162746, 14.377703999999994")
	
	; Debug GetGadgetItemAttribute(#myGoogleMap, 0, #GoogleMapMarkerPosition)
	
 	SetGadgetAttribute(#myGoogleMap, #GoogleMapCenter, 0) ; Center the map to Marker 0
 	
	BindGoogleMapEvents()
	
	BindGoogleMapMarkerEvents()
	
EndProcedure

Procedure GoogleMapsGeocoder2Error(Error.s)
	MessageRequester("GoogleMaps", Error)
EndProcedure

Procedure GoogleMapsGeocoder3Success(ResultCsv.s)
	MessageRequester("Success", ResultCsv)
EndProcedure
 
Procedure GoogleMapsGeocoder3Error(Error.s)
	MessageRequester("Error", Error)
EndProcedure

GoogleMapsGeocoder2("Berlin, Brandenburger Tor", @GoogleMapsGeocoder2Success(), @GoogleMapsGeocoder2Error())

; GoogleMapsGeocoder3(52.5162746, 13.377703999999994, @GoogleMapsGeocoder3Success(), @GoogleMapsGeocoder3Error())

DataSection
	IncludeBinary "case.png"
EndDataSection

; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 92
; Folding = E9
; EnableXP