﻿EnableExplicit

XIncludeFile "..\..\..\p2w.pbi"
XIncludeFile "..\..\..\UserGadgets\GoogleMapGadget\GoogleMapGadget.pbi"

Enumeration
	#myGoogleMap
	#cmdGridSize10
	#cmdGridSize60
	#cmdCluster
	#cmdUncluster
	#chkUseKeyDragZoom
	#chkZoomAfterDragging
	#lblUseKeyDragZoomHint
EndEnumeration

P2W_Converter_SetProfile("pb2webtest")

OpenLibrary(#PB_Any, "data.json")

Procedure SetGridSize10()
	SetGadgetAttribute(#myGoogleMap, #GoogleMapMarkerClustererGridSize, 10)
EndProcedure

Procedure SetGridSize60()
	SetGadgetAttribute(#myGoogleMap, #GoogleMapMarkerClustererGridSize, 60)
EndProcedure

Procedure Cluster()
	SetGadgetAttribute(#myGoogleMap, #GoogleMapUseMarkerClusterer, #True)
EndProcedure

Procedure Uncluster()
	SetGadgetAttribute(#myGoogleMap, #GoogleMapUseMarkerClusterer, #False)
EndProcedure

Procedure CheckBoundsForMarker(bnds)
	
	Protected Counter
	
	!	var selector = $("#g_" + myGoogleMap);
	
	Dim myMarkerArray(0)
	
	! myMarkerArray = selector.data("markerarray");
	
	For Counter = 0 To ArraySize(myMarkerArray()) - 1
		!	if (bnds.contains(myMarkerArray[Counter].position)) {
		Debug "Marker " + Str(Counter) + ": matched"
		!	}
	Next
	
EndProcedure

Procedure BindKeyDragZoomEvents(Gadget)
	
	Protected selector
	Protected myMap
	Protected myDragZoomObject
	
	!	selector = $("#g_" + Gadget);
	If selector
		!	myMap = selector.data("googlemap");
		If myMap
			!	myDragZoomObject = myMap.getDragZoomObject();
			If myDragZoomObject
				! // google.maps.event.addListener(myDragZoomObject, 'activate', function () { cDebugger.Debug('KeyDragZoom Activated'); });
				! // google.maps.event.addListener(myDragZoomObject, 'deactivate', function () { cDebugger.Debug('KeyDragZoom Deactivated'); });
				! // google.maps.event.addListener(myDragZoomObject, 'dragstart', function (latlng) { cDebugger.Debug('KeyDragZoom Started: ' + latlng); });
				! // google.maps.event.addListener(myDragZoomObject, 'drag', function (startPt, endPt) { cDebugger.Debug('KeyDragZoom Dragging: ' + startPt + endPt); });
				!	google.maps.event.addListener(myDragZoomObject, 'dragend', function (bnds) { CheckBoundsForMarker(bnds); });
			EndIf
		EndIf
	EndIf
	
EndProcedure

Procedure UnbindKeyDragZoomEvents(Gadget)
	
	Protected selector
	Protected myMap
	Protected myDragZoomObject
	
	!	selector = $("#g_" + Gadget);
	If selector
		!	myMap = selector.data("googlemap");
		If myMap
			!	myDragZoomObject = myMap.getDragZoomObject();
			If myDragZoomObject
				! // google.maps.event.clearListeners(myDragZoomObject, 'activate');
				! // google.maps.event.clearListeners(myDragZoomObject, 'deactivate');
				! // google.maps.event.clearListeners(myDragZoomObject, 'dragstart');
				! // google.maps.event.clearListeners(myDragZoomObject, 'drag');
				!	google.maps.event.clearListeners(myDragZoomObject, 'dragend');
			EndIf
		EndIf
	EndIf
	
EndProcedure

Procedure ZoomAfterDragging()
	
	If GetGadgetState(#chkZoomAfterDragging) = #PB_Checkbox_Checked
		SetGadgetAttribute(#myGoogleMap, #GoogleMapKeyDragZoomNoZoom, #False)
	Else
		SetGadgetAttribute(#myGoogleMap, #GoogleMapKeyDragZoomNoZoom, #True)
	EndIf
	
EndProcedure

Procedure UseKeyDragZoom()
	
	If GetGadgetState(#chkUseKeyDragZoom) = #PB_Checkbox_Checked
		SetGadgetAttribute(#myGoogleMap, #GoogleMapUseKeyDragZoom, #True)
		BindKeyDragZoomEvents(#myGoogleMap)
		DisableGadget(#chkZoomAfterDragging, #False)
		HideGadget(#lblUseKeyDragZoomHint, #False)
	Else
		UnbindKeyDragZoomEvents(#myGoogleMap)
		SetGadgetAttribute(#myGoogleMap, #GoogleMapUseKeyDragZoom, #False)
		DisableGadget(#chkZoomAfterDragging, #True)
		HideGadget(#lblUseKeyDragZoomHint, #True)
	EndIf
		
EndProcedure

FrameGadget(#PB_Any, 10, 10, 225, 100, "MarkerClusterer:")

ButtonGadget(#cmdGridSize10, 20, 30, 100, 30, "GridSize 10")
ButtonGadget(#cmdGridSize60, 20, 70, 100, 30, "GridSize 60")

BindGadgetEvent(#cmdGridSize10, @SetGridSize10())
BindGadgetEvent(#cmdGridSize60, @SetGridSize60())

ButtonGadget(#cmdCluster,   130, 30, 100, 30, "Cluster")
ButtonGadget(#cmdUncluster, 130, 70, 100, 30, "Uncluster")

BindGadgetEvent(#cmdCluster, @Cluster())
BindGadgetEvent(#cmdUncluster, @Uncluster())

FrameGadget(#PB_Any, 250, 10, 225, 100, "KeyDragZoom:")

CheckBoxGadget(#chkUseKeyDragZoom, 270, 40, 150, 30, "UseKeyDragZoom")
CheckBoxGadget(#chkZoomAfterDragging, 280, 60, 150, 30, "Zoom after dragging")
SetGadgetState(#chkZoomAfterDragging, #PB_Checkbox_Checked)
DisableGadget(#chkZoomAfterDragging, #True)

BindGadgetEvent(#chkUseKeyDragZoom, @UseKeyDragZoom())
BindGadgetEvent(#chkZoomAfterDragging, @ZoomAfterDragging())

GoogleMapGadget(#myGoogleMap, 10, 160, 640, 480)

SetGadgetAttribute(#myGoogleMap, #GoogleMapType, #GoogleMapTypeSatellite)
SetGadgetAttribute(#myGoogleMap, #GoogleMapZoom, 2)

LoadFont(0, "Arial", 14)
TextGadget(#lblUseKeyDragZoomHint, 10, 650, 640, 30, "Use &lt;Shift&gt; + Left Mousebutton to drag a rectangle", #PB_Text_Center)
SetGadgetFont(#lblUseKeyDragZoomHint, FontID(0))
FreeFont(0)
HideGadget(#lblUseKeyDragZoomHint, #True)


Define Counter
Define LatLng.s

; Add some sample Markers...

For Counter = 0 To 99
	! var dataPhoto = photodata.photos[Counter];
	! LatLng = dataPhoto.latitude + "," + dataPhoto.longitude;
 	AddGadgetItem(#myGoogleMap, -1, LatLng)
Next

SetGadgetAttribute(#myGoogleMap, #GoogleMapCenter, @"37.4419, -122.1419")

SetGadgetAttribute(#myGoogleMap, #GoogleMapUseMarkerClusterer, #True)

DataSection
	IncludeBinary "data.json"
EndDataSection
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 4
; Folding = Bw
; EnableUnicode
; EnableXP