EnableExplicit

XIncludeFile "..\..\..\p2w.pbi"
XIncludeFile "..\..\..\UserGadgets\SplitButtonGadget\SplitButtonGadget.pbi"

Enumeration
	#mySplitButtonGadget
EndEnumeration

Global SplitButton_X       =  10
Global SplitButton_Y       =  20
Global SplitButton_Width   = 300
Global SplitButton_Height  =  30

Procedure CheckValues(Value1, Value2, DebugOutputText.s)
	
	If Value1 = Value2
		Debug DebugOutputText + ": success"
	Else
		Debug DebugOutputText + ": failed"
		Debug "Value1: " + Str(Value1)
		Debug "Value2: " + Str(Value2)
	EndIf
	
EndProcedure

Procedure CheckValues2(Value1.s, Value2.s, DebugOutputText.s)
	
	If Value1 = Value2
		Debug DebugOutputText + ": success"
	Else
		Debug DebugOutputText + ": failed"
		Debug "Value1: " + Str(Value1)
		Debug "Value2: " + Str(Value2)
	EndIf
	
EndProcedure

Procedure TestSplitButtonGadget(SplitButtonGadget)
	
	If IsGadget(SplitButtonGadget)
		Debug "IsGadget(): success"
	Else
		Debug "IsGadget(): failed"
	EndIf
	
	CheckValues(GadgetX     (SplitButtonGadget), SplitButton_X,      "GadgetX()")
	CheckValues(GadgetY     (SplitButtonGadget), SplitButton_Y,      "GadgetY()")
	CheckValues(GadgetWidth (SplitButtonGadget), SplitButton_Width,  "GadgetWidth()")
	CheckValues(GadgetHeight(SplitButtonGadget), SplitButton_Height, "GadgetHeight()")
	
	ResizeGadget(SplitButtonGadget, 
	             SplitButton_X + 10, 
	             SplitButton_Y + 10,
	             SplitButton_Width + 10, 
	             SplitButton_Height + 10)
	
	CheckValues(GadgetX     (SplitButtonGadget), SplitButton_X + 10,      "GadgetX() after ResizeGadget()")
	CheckValues(GadgetY     (SplitButtonGadget), SplitButton_Y + 10,      "GadgetY() after ResizeGadget()")
	CheckValues(GadgetWidth (SplitButtonGadget), SplitButton_Width + 10,  "GadgetWidth() after ResizeGadget()")
	CheckValues(GadgetHeight(SplitButtonGadget), SplitButton_Height + 10, "GadgetHeight() after ResizeGadget()")
	
	; CountGadgetItems()
	
	Protected Counter 
	
	For Counter = 0 To 10
		AddGadgetItem(SplitButtonGadget, -1, "Item " + Str(Counter))
	Next
	
	CheckValues(CountGadgetItems(SplitButtonGadget), 11, "CountGadgetItems() after AddGadgetItem()")
	
	; RemoveGadgetItem() / CountGadgetItems()
	
	RemoveGadgetItem(SplitButtonGadget, 0)
	
	CheckValues(CountGadgetItems(SplitButtonGadget), 10, "CountGadgetItems() after RemoveGadgetItem()")
	
	; SetGadgetText() / GetGadgetText()
	
	SetGadgetText(SplitButtonGadget, "TestItem")
	
	CheckValues2(GetGadgetText(SplitButtonGadget), "TestItem", "GetGadgetText() after SetGadgetText()")
	
	; SetGadgetItemText() / GetGadgetItemText()
	
	SetGadgetItemText(SplitButtonGadget, 5, "TestItem 5")
	
	CheckValues2(GetGadgetItemText(SplitButtonGadget, 5), "TestItem 5", "GetGadgetItemText() after SetGadgetItemText()")
	
	; finally ClearGadgetItems() / CountGadgetItems()
	
	ClearGadgetItems(SplitButtonGadget)
	
	CheckValues(CountGadgetItems(SplitButtonGadget), 0, "CountGadgetItems() after ClearGadgetItems()")
	
	FreeGadget(SplitButtonGadget)
	
	If IsGadget(SplitButtonGadget)
		Debug "FreeGadget(): failed"
	Else
		Debug "FreeGadget(): success"
	EndIf
	
EndProcedure

; AddGadgetItem(): Add an item. 
; ClearGadgetItems(): Remove all the items. 
; CountGadgetItems(): Count the items in the current SplitButton. 
; -GetGadgetItemData(): Returns the value that was stored with item. 
; GetGadgetItemText(): Returns the gadget item text. 
; GetGadgetState(): Get the index (starting from 0) of the current element. 
; GetGadgetText(): Get the (text) content of the current element. 
; RemoveGadgetItem(): Remove an item. 
; -SetGadgetItemData(): Stores a value with the item. 
; -SetGadgetItemImage(): Changes the gadget item image
; SetGadgetItemText(): Changes the gadget item text. 
; SetGadgetState(): Change the selected element. 
; SetGadgetText(): Set the displayed text.

; OpenWindow(#myWindow, 10, 10, 500, 300, "SplitButtonGadget-Test")

Define NumberOfDomElements

Debug "Testing #mySplitButtonGadget..."

! NumberOfDomElements = $('*').length;

Debug "Number of DOM Elements: " + Str(NumberOfDomElements)

SplitButtonGadget(#mySplitButtonGadget, SplitButton_X, SplitButton_Y, SplitButton_Width, SplitButton_Height, "SplitButtonText")
TestSplitButtonGadget(#mySplitButtonGadget)

! NumberOfDomElements = $('*').length;

Debug "Number of DOM Elements: " + Str(NumberOfDomElements)
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 1
; Folding = 6
; EnableXP