EnableExplicit

XIncludeFile "..\..\..\p2w.pbi"
XIncludeFile "..\..\..\UserGadgets\UploadGadget\UploadGadget.pbi"

P2W_Converter_SetProfile("pb2webtest")

Enumeration
	#myWindow
	#myUploadGadget
EndEnumeration

EnablePHP

ProcedureDLL Upload()
	
	!	if(isset($_FILES["file"]) && $_FILES["file"]["error"]== UPLOAD_ERR_OK) {
	
	!		$UploadDirectory = 'uploads/'; // specify upload directory ends with / (slash)
	
	! 	if (!is_dir($UploadDirectory)) {
	!     echo json_encode(array('status' => 'error', 'message' => 'upload folder doesnt exists'));
	!     die();
	!   }
	
	!		//check if this is an ajax request
	!		if (!isset($_SERVER['HTTP_X_REQUESTED_WITH'])) die();
	
	!		//Is file size is less than allowed size.
	!		if ($_FILES["file"]["size"] > 5242880) { 
	!     echo json_encode(array('status' => 'File size is too big'));
	!     die();
	!   }
	!    
	!		//allowed file type Server side check
	!		switch(strtolower($_FILES['file']['type'])) {
	!			//allowed file types
	!			case 'image/png': 
	!			case 'image/gif': 
	!			case 'image/jpeg': 
	!			case 'image/pjpeg':
	!				break;
	!			default:
	!       echo json_encode(array('status' => 'Unsupported File'));
	!				die();
	!		}
	
	!		$FileName = strtolower($_FILES['file']['name']);
	
	!		if(move_uploaded_file($_FILES['file']['tmp_name'], $UploadDirectory.$FileName )) {
	! 		echo json_encode(array('status' => 'ok', 'message' => 'ok'));
	!			die();
	!		} else {
	!     echo json_encode(array('status' => 'error', 'message' => 'error uploading File'));
	!			die();
	!		}
	
	!	} else {
	!		echo json_encode(array('status' => 'Something wrong with upload'));
	!		die();
	!	}
	
EndProcedure

DisablePHP

Procedure DebugFileInfo(*file.sUploadFile)
	
	Debug "Filename: " + *file\name
	Debug "Filesize: " + *file\size
	Debug "Filetype: " + *file\type
	
EndProcedure

Procedure onDrop(event)
	
	Debug "onDrop()"
	Debug event	
	
EndProcedure

Procedure onAddedFile(*file.sUploadFile)
	
	Debug "onAddedFile()"
	
	DebugFileInfo(*file)	

	If LCase(GetExtensionPart(*file\name)) <> "png" ; accept only png-files (for example)
		Debug "Only PNG-Files are allowed!"
		Debug "---------------------"
		RemoveGadgetItem(#myUploadGadget, *file) ; this will fire a
	EndIf
	
	Debug "---------------------"
	
EndProcedure

Procedure onRemovedFile(*file.sUploadFile)
	
	Debug "onRemovedFile()"
	
	DebugFileInfo(*file)	

	Debug "---------------------"
	
EndProcedure

Procedure onError(*file.sUploadFile, errorMessage)
	
	Debug "onError()"
	
	DebugFileInfo(*file)
	
	Debug errorMessage
	Debug "---------------------"
	
EndProcedure

Procedure onUploadProgress(*file, progress, bytesSent)
	
	Debug "onUploadProgress()"
	
	DebugFileInfo(*file)
		
	Debug "progress: " + Str(progress)
	Debug "bytesSent: " + Str(bytesSent)
	
	Debug "---------------------"
	
EndProcedure

Procedure onTotalUploadProgress(totalPercentage, totalBytesToBeSent, totalBytesSent)
	
	Debug "onTotalUploadProgress()"
	Debug "totalPercentage: " + Str(totalPercentage)
	Debug "totalBytesToBeSent: " + Str(totalBytesToBeSent)
	Debug "totalBytesSent: " + Str(totalBytesSent)
	
	Debug "---------------------"
	
EndProcedure

Procedure onSuccess(*file, response)
	
	Debug "onSuccess()"
	
	DebugFileInfo(*file)
	
	Protected UploadResponse.sUploadResponse
	
	ParseJSON(0, Str(response))
	ExtractJSONStructure(JSONValue(0), @UploadResponse.sUploadResponse, sUploadResponse)
	FreeJSON(0)
	
 	Debug "Status: " + UploadResponse\status
 	Debug "Message: " + UploadResponse\message
 	
 	Debug "---------------------"
	
EndProcedure

Procedure onAll(a,b,c,d)
	
	Select EventType()
			
		Case #PB_EventType_Upload_Drop : Debug "PB_EventType_Upload_Drop"
		Case #PB_EventType_Upload_DragStart : Debug "PB_EventType_Upload_DragStart"
		Case #PB_EventType_Upload_DragEnd : Debug "PB_EventType_Upload_DragEnd"
		Case #PB_EventType_Upload_DragEnter : Debug "PB_EventType_Upload_DragEnter"
		Case #PB_EventType_Upload_DragOver : Debug "PB_EventType_Upload_DragOver"
		Case #PB_EventType_Upload_DragLeave : Debug "PB_EventType_Upload_DragLeave"
		Case #PB_EventType_Upload_AddedFile : Debug "PB_EventType_Upload_AddedFile"
		Case #PB_EventType_Upload_RemovedFile : Debug "PB_EventType_Upload_RemovedFile"
		Case #PB_EventType_Upload_Thumbnail : Debug "PB_EventType_Upload_Thumbnail"
		Case #PB_EventType_Upload_Error : Debug "PB_EventType_Upload_Error"
		Case #PB_EventType_Upload_Processing : Debug "PB_EventType_Upload_Processing"
		Case #PB_EventType_Upload_Sending : Debug "PB_EventType_Upload_Sending"
		Case #PB_EventType_Upload_Complete : Debug "PB_EventType_Upload_Complete"
		Case #PB_EventType_Upload_Canceled : Debug "PB_EventType_Upload_Canceled"
		Case #PB_EventType_Upload_MaxFilesReached : Debug "PB_EventType_Upload_MaxFilesReached"
		Case #PB_EventType_Upload_MaxFilesExceeded : Debug "PB_EventType_Upload_MaxFilesExceeded"
		
	EndSelect
	
	If a : Debug "a: " + Str(a) : EndIf
	If b : Debug "b: " + Str(b) : EndIf
	If c : Debug "c: " + Str(c) : EndIf
	If d : Debug "d: " + Str(d) : EndIf
	
	Debug "---------------------"
	
EndProcedure

Procedure Main()
	
	OpenWindow(#myWindow, #PB_Ignore, #PB_Ignore, 400, 400, "UploadGadget()", #PB_Window_ScreenCentered)
	
	; Usage:
	
	; UploadGadget(#myUploadGadget, 
	;              x, 
	;              y, 
	;              Width,
	;              Height,
	;              Target.s,
	;              Text.s)
	
	
	Protected TargetUrl.s = "test.php?request=Upload"
	
	UploadGadget(#myUploadGadget, 10, 10, WindowWidth(#myWindow) - 20, WindowHeight(#myWindow) - 20, TargetUrl)
	
;	  BindGadgetEvent(#myUploadGadget, @onAll(), #PB_All)
 	BindGadgetEvent(#myUploadGadget, @onAddedFile(), #PB_EventType_Upload_AddedFile)
 	BindGadgetEvent(#myUploadGadget, @onUploadProgress(), #PB_EventType_Upload_UploadProgress)
 	BindGadgetEvent(#myUploadGadget, @onTotalUploadProgress(), #PB_EventType_Upload_TotalUploadProgress)
 	BindGadgetEvent(#myUploadGadget, @onSuccess(), #PB_EventType_Upload_Success)
 	;BindGadgetEvent(#myUploadGadget, @onRemovedFile(), #PB_EventType_Upload_RemovedFile)
	
EndProcedure

Main()
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 6
; Folding = ---
; EnableXP