
; Example to work with the websocket-server from Dadido3
; http://www.purebasic.fr/german/viewtopic.php?p=328601#p328601

XIncludeFile "..\..\p2w.pbi"

XIncludeFile "Websocket.pbf"

P2W_Converter_SetProfile("pb2webtest")

EnableExplicit

Global myWebsocket
Global Connected = #False	

Structure Chat_Username_Change
  Type.s
  Username.s
EndStructure

Structure Chat_Message
  Type.s
  Author.s
  Message.s
  Timestamp.q
EndStructure

Procedure AddLog(Message.s)
	AddGadgetItem(#lstMessages, -1, Message)
	SetGadgetState(#lstMessages, CountGadgetItems(#lstMessages) - 1)
EndProcedure

Procedure WS_OnOpen()
	
	Connected = #True
	
	SetGadgetText(#cmdConnect, "Disconnect")
	
	AddLog("WS_OnOpen")
	
	Protected Message.Chat_Username_Change
	
	Message\Type     = "Username_Change"
	Message\Username = "USER_12345"
	
	CreateJSON(0)
	InsertJSONStructure(JSONValue(0), @Message, Chat_Username_Change)
	Protected JSON.s = ComposeJSON(0)
	SendWebsocket(myWebsocket, @JSON)
	FreeJSON(0)
	
EndProcedure

Procedure WS_OnClose()
	
	Connected = #False
	
	SetGadgetText(#cmdConnect, "Connect")
	
	AddLog("WS_OnClose")
	
EndProcedure

Procedure WS_OnMessage(Message.s)
	
	AddLog("WS_OnMessage: " + Message)
	
EndProcedure

Procedure WS_OnError(Error.s)
	
	AddLog("WS_OnError: " + Error)
	
EndProcedure

Procedure cmdConnect_Event()
	
	If Not Connected
		
		myWebsocket = OpenWebsocket("ws://127.0.0.1:8090")
		
		If myWebsocket
			
			BindNetworkEvent(myWebsocket, @WS_OnOpen(),    #PB_Event_Websocket_OnOpen)
			BindNetworkEvent(myWebsocket, @WS_OnClose(),   #PB_Event_Websocket_OnClose)
			BindNetworkEvent(myWebsocket, @WS_OnMessage(), #PB_Event_Websocket_OnMessage)
			BindNetworkEvent(myWebsocket, @WS_OnError(),   #PB_Event_Websocket_OnError)
			
			AddLog("WebSocket: OK")
			
		Else
			
			AddLog("WebSocket: not OK!")
			
		EndIf		
		
	Else
		
		AddLog("Closing connection...")
		CloseWebsocket(myWebsocket)
		
	EndIf
	
EndProcedure

Procedure cmdSend_Event()
	
	If Not Connected
		ProcedureReturn
	EndIf
	
	Protected TextToSend.s = GetGadgetText(#txtSend)
	
	If TextToSend = ""
		ProcedureReturn
	EndIf
	
	AddLog("Sending '" + TextToSend + "'")
	
	Protected Message.Chat_Message
	
	Message\Type = "Message"
	Message\Author = "USER_12345"
	Message\Message = TextToSend
	Message\Timestamp = Date()
	
	CreateJSON(0)
	InsertJSONStructure(JSONValue(0), @Message, Chat_Message)
	Protected JSON.s = ComposeJSON(0)
	SendWebsocket(myWebsocket, @JSON)
	FreeJSON(0)
	
EndProcedure

OpenWindow_0()

BindGadgetEvent(#cmdConnect, @cmdConnect_Event())
BindGadgetEvent(#cmdSend, @cmdSend_Event())

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 10
; Folding = --
; EnableXP