XIncludeFile "..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

EnableExplicit

If InitMovie() = 0
	MessageRequester("Movie", "Can't initialize movie playback!")
	End
EndIf

Enumeration
	
	#myWindow
	#myMovie
	#lblTime
	#lblVolume
	#cmdShowHideControls
	
EndEnumeration

Procedure SizeWindowEvent()
	
	ResizeMovie(#myMovie, #PB_Ignore, #PB_Ignore, WindowWidth(#myWindow) - 30, WindowHeight(#myWindow) - 20)
	
EndProcedure

Procedure MovieEvent()
	
	Protected mWidth = 0
	Protected mHeight = 0

	Select EventType()
			
		Case #PB_Event_Movie_Abort
			Debug "PB_Event_Movie_Abort"
			
		Case #PB_Event_Movie_CanPlay
			Debug "PB_Event_Movie_CanPlay"
			
		Case #PB_Event_Movie_CanPlayThrough
			Debug "PB_Event_Movie_CanPlayThrough"
			
		Case #PB_Event_Movie_DurationChange
			Debug "PB_Event_Movie_DurationChange"
			
		Case #PB_Event_Movie_Emptied
			; Debug "PB_Event_Movie_Emptied"
			
		Case #PB_Event_Movie_Ended 
			Debug "PB_Event_Movie_Ended"
			
		Case #PB_Event_Movie_Error 
			Debug "PB_Event_Movie_Error"
			
		Case #PB_Event_Movie_LoadedData
			Debug "PB_Event_Movie_LoadedData"
			
		Case #PB_Event_Movie_LoadedMetaData
			Debug "PB_Event_Movie_LoadedMetaData"
			
		Case #PB_Event_Movie_LoadStart
			Debug "PB_Event_Movie_LoadStart"
			
		Case #PB_Event_Movie_Pause
			Debug "PB_Event_Movie_Pause"
			
		Case #PB_Event_Movie_Play
			Debug "PB_Event_Movie_Play"
			
		Case #PB_Event_Movie_Playing
			Debug "PB_Event_Movie_Playing"
			
		Case #PB_Event_Movie_Progress
			; Debug "PB_Event_Movie_Progress"
			
		Case #PB_Event_Movie_RateChange
			Debug "PB_Event_Movie_RateChange"
			
		Case #PB_Event_Movie_Seeked
			Debug "PB_Event_Movie_Seeked"
			
		Case #PB_Event_Movie_Seeking
			Debug "PB_Event_Movie_Seeking"
			
		Case #PB_Event_Movie_Stalled
			Debug "PB_Event_Movie_Stalled"
			
		Case #PB_Event_Movie_Suspend
			; Debug "PB_Event_Movie_Suspend"
			
		Case #PB_Event_Movie_TimeUpdate
			; Debug "PB_Event_Movie_TimeUpdate"
			SetGadgetText(#lblTime, "Time [s]: " + Str(P2W_GetMovieAttribute(#myMovie, #PB_Movie_CurrentTime)))
			
		Case #PB_Event_Movie_VolumeChange
			; Debug "PB_Event_Movie_VolumeChange"
			SetGadgetText(#lblVolume, "Volume: " + Str(P2W_GetMovieAttribute(#myMovie, #PB_Movie_Volume)))
			
		Case #PB_Event_Movie_Waiting
			; Debug "PB_Event_Movie_Waiting"
			
		Default
			; Debug Str(EventType()) + ": ???"
			
	EndSelect
	
	mWidth = MovieWidth(#myMovie)
	mHeight = MovieHeight(#myMovie)
	
	If mWidth > 0 And mHeight > 0
		
		If Not(IsWindow(#myWindow))
			
			Debug "MovieWidth: "  + Str(mWidth)
			Debug "MovieHeight: " + Str(mHeight)
			
			ResizeMovie(#myMovie, #PB_Ignore, #PB_Ignore, mWidth, mHeight)
			OpenWindow(#myWindow, 100, 100, mWidth + 30, mHeight + 20, "PureBasic - Movie", #PB_Window_SizeGadget)
			PlayMovie(#myMovie, WindowID(#myWindow))
			SetGadgetText(#lblVolume, "Volume: " + Str(P2W_GetMovieAttribute(#myMovie, #PB_Movie_Volume)))
			DisableGadget(#cmdShowHideControls, #False)
			
			BindEvent(#PB_Event_SizeWindow, @SizeWindowEvent(), #myWindow)        
			
		EndIf
		
	EndIf
	
EndProcedure

Procedure ShowHideControls()
	
	If P2W_GetMovieAttribute(#myMovie, #PB_Movie_ShowControls) = #False
		P2W_SetMovieAttribute(#myMovie, #PB_Movie_ShowControls, #True)
	Else
		P2W_SetMovieAttribute(#myMovie, #PB_Movie_ShowControls, #False)
	EndIf
	
EndProcedure

; http://caniuse.com/#feat=video
; http://www.w3.org/wiki/HTML/Elements/video

TextGadget(#lblTime, 10, 10, 200, 20, "Time [s]: 0")
TextGadget(#lblVolume, 10, 40, 200, 20, "Volume: 0")

ButtonGadget(#cmdShowHideControls, 10, 60, 200, 30, "Show / Hide Controls")
GadgetToolTip(#cmdShowHideControls, "Move the cursor over the movie to see the controls")
BindGadgetEvent(#cmdShowHideControls, @ShowHideControls())
DisableGadget(#cmdShowHideControls, #True)

If LoadMovie(#myMovie, "http://clips.vorwaerts-gmbh.de/VfE.webm") 
	
	MovieAudio(#myMovie, 0, 0)
	
	P2W_BindMovieEvent(#myMovie, @MovieEvent()) ; Bind all events
	
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_Abort)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_CanPlay)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_CanPlayThrough)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_DurationChange)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_Emptied)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_Ended)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_Error)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_LoadedData)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_LoadedMetaData)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_LoadStart)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_Pause)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_Play)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_Playing)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_Progress)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_RateChange)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_Seeked)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_Seeking)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_Stalled)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_Suspend)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_TimeUpdate)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_VolumeChange)
	; P2W_BindMovieEvent(#myMovie, @MovieEvent(), #PB_Event_Movie_Waiting)
	
Else
	
	MessageRequester("Movie", "Your browser does not support the video tag.<br />See <a href='http://caniuse.com/#feat=video' target='_blank'>supported browser.</a>")
	
EndIf
; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 160
; FirstLine = 120
; Folding = -
; EnableXP