<?php

/**
 * cSort short summary.
 *
 * cSort description.
 *
 * @version 1.0
 * @author Nico Grener
 */

require_once("cCommon.php");
require_once("cConstants.php");


class cSort
{
    
    static function SortArray(&$ArrayName, $Flags = cConstants::PB_Sort_NoCase, $Start = -1, $End = -1 )
    {
        if (($Start > -1 ) || ($End > -1) || ($End > $Start)) {
            
            // we copy the array
            $objArrayName1 = new ArrayObject($ArrayName);
            $tempArrayName1 = $objArrayName1->getArrayCopy();
            
            $length1 = count($tempArrayName1);
            
            // because we must "slice" it to the given $start and $end parameter
            $sliceLength = ($End - $Start +1);
            $slicedArray = array_slice($tempArrayName1, $Start, $sliceLength);
            
            // lets check the new length of the array (count of elements in the array)
            $length = count($slicedArray);
               
            // time to sort the array
            if ($Flags === cConstants::PB_Sort_NoCase){
                sort($slicedArray);            
            } elseif ($Flags === cConstants::PB_Sort_Ascending) {
                sort($slicedArray);               
            } elseif ($Flags === cConstants::PB_Sort_Descending) {
                rsort($slicedArray);               
            }
            
            // bring together the two arrays with the given $start and $end paramater
            array_splice($ArrayName, $Start, $sliceLength, $slicedArray);
            
            
        } else {
            
            //lets sort the array
            if ($Flags === cConstants::PB_Sort_NoCase){
                sort($ArrayName);            
            } elseif ($Flags === cConstants::PB_Sort_Ascending) {
                sort($ArrayName);              
            } elseif ($Flags === cConstants::PB_Sort_Descending) {
                rsort($ArrayName);               
            }
                                
        }
        
    }
    
    
}
