
#PB_WidgetType_Button       = "Button"
#PB_WidgetType_String       = "String"
#PB_WidgetType_ListView     = "ListView"
#PB_WidgetType_HeaderButton = "HeaderButton"
#PB_WidgetType_Container    = "Container"
#PB_WidgetType_Spacer       = "Spacer"
#PB_WidgetType_Navbar       = "Navbar"
#PB_WidgetType_Controlgroup = "Controlgroup"
#PB_WidgetType_ListItem     = "ListItem"

; Attributes:

#PB_Button_Icon = 1
#PB_Button_Inline = 2
#PB_Button_Mini = 3
#PB_Button_IconPosition = 4
#PB_Button_IconPosition_Left = 1
#PB_Button_IconPosition_Right = 2
#PB_Button_IconPosition_Top = 3
#PB_Button_IconPosition_Bottom = 4
#PB_Button_IconPosition_NoText= 5

#PB_ListView_DataFilter = 1
#PB_ListView_DataFilterPlaceholder = 2

#PB_Orientation_Horizontal = "horizontal"
#PB_Orientation_Vertical = "vertical"


UseMobile()


! var currentPage;
! var currenContainer;

Procedure SetPageHeader(Page, Text.s)
	
	! var selector = $("#page_" + Page).find("div[data-role='header']").find("h1");
	! selector.text(Text);	
	! $.mobile.resetActivePageHeight();
	
EndProcedure

Procedure SetPageFooter(Page, Text.s)
	
	! var selector = $("#page_" + Page).find("div[data-role='footer']").find("h1");
	! selector.text(Text);	
	! $.mobile.resetActivePageHeight();
	
EndProcedure

Procedure HidePageHeader(Page, State)
	! var selector = $("#page_" + Page).find("div[data-role='header']");
	! if (State==false || State==0) {
	!		selector.show();
	! } else {
	!		selector.hide();
	! }
	! $.mobile.resetActivePageHeight();
EndProcedure

Procedure HidePageFooter(Page, State)
	! var selector = $("#page_" + Page).find("div[data-role='footer']");
	! if (State==false || State==0) {
	!		selector.show();
	! } else {
	!		selector.hide();
	! }
	! $.mobile.resetActivePageHeight();
EndProcedure

Procedure OpenPage(Page, BackPage=-1)
	
	Protected myDiv.s
	Protected BackButton.s
	
	If BackPage = -1
		BackButton = "data-add-back-btn='false'"
	Else
		BackButton = "data-add-back-btn='true'"
	EndIf
	
	myDiv = "<div data-role='page'>" + 
	        "<div data-role='header' data-position='fixed' " + BackButton + "><h1 /></div>" + 
	        "<div class='ui-content' role='main' />" + 
	        "<div data-role='footer' data-position='fixed'><h1 /></div>" + 
	        "</div>"
	
	! var selector = $(myDiv);
	! if (Page == cConstants.PB_Any) Page = cCommon.guid();
	! if ($("#page_" + Page).length > 0) ClosePage(Page);
	! selector.attr("id", "page_" + Page);
	
	! currentPage = Page;
	! currentContainer = selector.find(".ui-content");
	! selector.page();
	
	! $("body").append(selector);
	! $(":mobile-pagecontainer").pagecontainer( "change", $("#page_" + Page) );
	
	! // $.mobile.resetActivePageHeight();
	
	!	selector.on("click", "[data-rel=back]", function (e) {
	If BackPage > -1
		!		e.stopImmediatePropagation();
		!		e.preventDefault();
		!		$.mobile.changePage("#page_" + BackPage);
	EndIf
	!	});
	
	
	! return Page;
	
EndProcedure

Procedure ClosePage(Page)
	! var selector = $("#page_" + Page);
	! selector.remove();
EndProcedure

Procedure HeaderWidget(Widget, Text.s = "")
	
	If Trim(Text) = ""
	! var selector = $("<a href='#' class='ui-btn ui-corner-all ui-btn-inline ui-mini ui-btn-left ui-btn-icon-left ui-icon-refresh' data-iconpos='notext'>&nbsp;</a>");
	Else
	! var selector = $("<a href='#' class='ui-btn ui-corner-all ui-btn-inline ui-mini ui-btn-left ui-btn-icon-left ui-icon-refresh'>" + Text + "</a>");
	EndIf
	
		
	
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	! selector.attr("id", "widget_" + Widget);
	! selector.data("WidgetType", PB_WidgetType_HeaderButton);
	
	! selector.bind("click", function (event, ui) {
	! 	var cb = selector.data("onLeftClick");
	! 	if (typeof cb === "function") {
	! 		if (event.which === 1) {
	! 			cb();
	! 		}
	! 	}
	! });		
	
	! $("#page_" + currentPage).find("div[data-role='header']").prepend(selector);
	! return Widget;
	
EndProcedure

Procedure FooterButton(FooterButton, Text.s)
	
	! var selector = $("<a href='#' class='ui-btn ui-corner-all ui-btn-inline ui-mini ui-btn-left ui-btn-icon-left ui-icon-power'>" + Text + "</a>");
	! $("#footer_" + currentFooter).prepend(selector);
	
EndProcedure

Procedure RemovePage(Page)
EndProcedure

Procedure ShowPage(Page)
	!	setTimeout(function () {
	! 	$("body").pagecontainer( "change", "#page_" + Page );
	!	}, 100); // delay above zero	
EndProcedure

Procedure HidePage(Page)
	!	setTimeout(function () {
	! 	var selector = $("#page_" + Page);
	! 	selector.hide();
	!	}, 100); // delay above zero	
EndProcedure

Procedure.s GetWidgetType(Widget)

	!	var selector = $("#widget_" + Widget);
	!	if (selector.length === 0) return; // cCommon.WidgetIsNotInitialized("WidgetType()");
	! return selector.data("WidgetType");

EndProcedure

Procedure ButtonWidget_BindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_LeftClick
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", Callback);
	
EndProcedure
Procedure ButtonWidget_UnbindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_LeftClick
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", null);
	
EndProcedure

Procedure ListViewWidget_BindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_LeftClick
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", Callback);
	
EndProcedure
Procedure ListViewWidget_UnbindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_LeftClick
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", null);
	
EndProcedure

Procedure HeaderButton_BindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_LeftClick
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", Callback);
	
EndProcedure
Procedure HeaderButton_UnbindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_LeftClick
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", null);
	
EndProcedure

Procedure StringWidget_BindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_KeyUp
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyUp)) selector.data("onKeyUp", Callback);
	
EndProcedure
Procedure StringWidget_UnbindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	! var selector = $("#widget_" + Widget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_KeyUp
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyUp)) selector.data("onKeyUp", null);
	
EndProcedure

Procedure BindWidgetEvent(Widget, Callback, EventType = #PB_All)
	
	Protected WidgetType.s = GetWidgetType(Widget)
	
	Select WidgetType
		Case #PB_WidgetType_Button
			ButtonWidget_BindWidgetEvent(Widget, Callback, EventType)
		Case #PB_WidgetType_ListView
			ListViewWidget_BindWidgetEvent(Widget, Callback, EventType)
		Case #PB_WidgetType_String
			StringWidget_BindWidgetEvent(Widget, Callback, EventType)
		Case #PB_WidgetType_HeaderButton
			HeaderButton_BindWidgetEvent(Widget, Callback, EventType)
	EndSelect
	
EndProcedure

Procedure FreeWidget(Widget)
	
	! var selector = $("#widget_" + Widget);
	
	Protected WidgetType.s = GetWidgetType(Widget)
	
	Select WidgetType
		Case #PB_WidgetType_String
			! $("label[for='widget_' + Widget]").remove();
			
	EndSelect	
	
	! selector.remove();
	
EndProcedure

Procedure CloseWidgetList()
	
	! currentContainer = currentContainer.parent().parent();
	
	!	currentContainer.trigger( "create" );
	
EndProcedure

Procedure ButtonWidget(Widget, Text.s)
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! var selector = $("<button />");
	! selector.attr("id", "widget_" + Widget);
	! selector.addClass("ui-btn");
	! selector.text(Text);
	! selector.data("WidgetType", PB_WidgetType_Button);
	
	! selector.bind("click", function (event, ui) {
	! 	var cb = selector.data("onLeftClick");
	! 	if (typeof cb === "function") {
	! 		if (event.which === 1) {
	! 			cb(event, ui);
	! 		}
	! 	}
	! });	
	
	! currentContainer.append(selector.button());
	
	! return Widget;

EndProcedure

Procedure ControlgroupWidget(Widget, Orientation.s = #PB_Orientation_Vertical)
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! var selector = $("<div />");
	
	! selector.attr("id", "widget_" + Widget);
	! selector.attr("data-role", "controlgroup");
	! selector.attr("data-type", Orientation);
	! selector.data("WidgetType", PB_WidgetType_Controlgroup);
	! currentContainer.append(selector.controlgroup());
	! return Widget;
	
EndProcedure

Procedure NavbarWidget(Widget)
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! var selector = $("<div />");
	! selector.append($("<ul />"));
	! selector.attr("id", "widget_" + Widget);
	! selector.attr("data-role", "navbar");
	! selector.data("WidgetType", PB_WidgetType_Navbar);
	! currentContainer.append(selector);
	! return Widget;
	
EndProcedure

Procedure ListItemWidget(Widget, Text.s)
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! var selector = $("<li />");
	! selector.attr("id", "widget_" + Widget);
	
	! var a = selector.append($("<a />"));
	! a.attr("href", "#");
	! a.addClass("ui-btn-active");
	! a.text(Text);
	
	! selector.data("WidgetType", PB_WidgetType_ListItem);
	! currentContainer.append(selector);
	! return Widget;
	
EndProcedure

Procedure StringWidget(Widget, LabelText.s, WidgetText.s = "", Flags = 0)
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! var type = " type='text' ";
	! var datatype = "";
	
	!	if (cCommon.CheckFlag(Flags, cConstants.PB_String_Numeric)) {
	! 	type = " type='number' ";
	! } else if (cCommon.CheckFlag(Flags, cConstants.PB_String_Password)) {
	! 	type = " type='password' ";
	! } else if (cCommon.CheckFlag(Flags, cConstants.PB_String_Search)) {
	! 	type = " type='text' ";
	! 	datatype = " data-type='search' ";
	! }
	
	! var selector = $("<label for='widget_" + Widget + "'>" + LabelText + "</label><input " + type + " " + datatype + " id='widget_" + Widget + "' value='" + WidgetText + "'>");
	
	! selector.data("WidgetType", PB_WidgetType_String);
	! currentContainer.append(selector);
	
	! $("#widget_" + Widget).textinput();
	
	! $("#widget_" + Widget).on("keyup", function () {
	! 	var cb = $("#widget_" + Widget).data("onKeyUp");
	! 	if (typeof cb === "function") {
	!			cb();
	! 	}
	! });
	
	! return Widget;
	
EndProcedure

Procedure ListViewWidget(Widget)
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	!	var selector = $("<ul />");
	
	! selector.attr("id", "widget_" + Widget);
	! selector.attr("data-role", "listview");
	! selector.attr("data-inset", "true");
	
	! selector.data("DataFilter", false);
	! selector.data("DataFilterPlaceholder", "Filter...");
	
	! selector.data("WidgetType", PB_WidgetType_ListView);
		
	! currentContainer.append(selector);
	
	!	selector.listview().listview('refresh');	
	
	! selector.on('click', ' > li', function () {
	! 	var cb = selector.data("onLeftClick");
	! 	if (typeof cb === "function") {
	! 		if (event.which === 1) {
	!     	var selectedIndex = $(this).index();
	!     	var selectedText  = $(this).text();
	! 			cb(selectedIndex, selectedText);
	! 		}
	! 	}
	! });	
	
	! return Widget;
	
EndProcedure

Procedure SetWidgetAttribute_Button(Widget, Attribute, Value)
	
	! var selector = $("#widget_" + Widget);
	
	Select Attribute
			
		Case #PB_Button_Icon
			! selector.buttonMarkup({ icon: Value });
			
		Case #PB_Button_Inline
			
			Select Value
				Case #True
					! selector.addClass("ui-btn-inline");
				Case #False
					! selector.removeClass("ui-btn-inline");
			EndSelect
			
		Case #PB_Button_Mini
			
			Select Value
				Case #True
					! selector.addClass("ui-mini");
				Case #False
					! selector.removeClass("ui-mini");
			EndSelect
			
		Case #PB_Button_IconPosition
			
			! selector.removeClass("ui-btn-icon-left");
			! selector.removeClass("ui-btn-icon-right");
			! selector.removeClass("ui-btn-icon-top");
			! selector.removeClass("ui-btn-icon-bottom");
			! selector.removeClass("ui-btn-icon-notext");
			
			Select Value
				Case #PB_Button_IconPosition_Right
					! Value = "right";
				Case #PB_Button_IconPosition_Top
					! Value = "top";
				Case #PB_Button_IconPosition_Bottom
					! Value = "bottom";
				Case #PB_Button_IconPosition_NoText
					! Value = "notext";
				Default
					! Value = "left";
			EndSelect
			
			! selector.addClass("ui-btn-icon-" + Value);
			
	EndSelect
	
EndProcedure

Procedure SetWidgetAttribute_ListView(Widget, Attribute, Value)
	
	! var selector = $("#widget_" + Widget);
	
	Select Attribute
			
		Case #PB_ListView_DataFilter
			
			Select Value
				Case #True
					! selector.data("DataFilter", true);
				Case #False
					! selector.data("DataFilter", false);
			EndSelect
	
		Case #PB_ListView_DataFilterPlaceholder
			! selector.data("DataFilterPlaceholder", Value);
			
	EndSelect
	
	! selector.attr("data-filter", selector.data("DataFilter"));
	
	!	currentContainer.trigger( "create" );
	
	! selector.parent().find("input").attr("placeholder", selector.data("DataFilterPlaceholder"));

EndProcedure

Procedure SetWidgetAttribute(Widget, Attribute, Value)
	
	Protected WidgetType.s = GetWidgetType(Widget)
	
	Select WidgetType
		Case #PB_WidgetType_Button
			SetWidgetAttribute_Button(Widget, Attribute, Value)
		Case #PB_WidgetType_ListView
			SetWidgetAttribute_ListView(Widget, Attribute, Value)
		Case #PB_WidgetType_String
		Case #PB_WidgetType_HeaderButton
	EndSelect
	
EndProcedure

Procedure AddWidgetItem_Controlgroup(Widget, Item)
	
	! $("#widget_" + Widget).find(".ui-controlgroup-controls").append($("#widget_" + Item));
	
EndProcedure

Procedure AddWidgetItem_Navbar(Widget, Item)
	
	! var selector = $("#widget_" + Widget);
	! if (selector.find("li").length > 0) selector.navbar("destroy");
	! selector = clearNavBarStyle(selector);
	! selector.find("ul").append($("#widget_" + Item));
	! selector.navbar();
	! selector.navbar('refresh');
	
EndProcedure

Procedure clearNavBarStyle(navbar)
	
	!	navbar.find("*").andSelf().each(function(){
	!		$(this).removeClass(function(i, cn){
	!			var matches = cn.match (/ui-[\w\-]+/g) || [];
	!   	return (matches.join (' '));
	!   });
	!		if ($(this).attr("class") == "") {
	!			$(this).removeAttr("class");
	!		}
	!	});
	!	return navbar;   
	
EndProcedure

Procedure AddWidgetItem(Widget, Item)
	
	Protected WidgetType.s = GetWidgetType(Widget)
	
	Select WidgetType
		Case #PB_WidgetType_Controlgroup
			AddWidgetItem_Controlgroup(Widget, Item)
		Case #PB_WidgetType_Navbar
			AddWidgetItem_Navbar(Widget, Item)
	EndSelect
	
EndProcedure

Procedure AddWidgetItems(Widget, Items.s)
	
	! var selector = $("#widget_" + Widget);
	
	! selector.append(Items);
	
; 	For Counter = 0 To CountString(Items, #CRLF$)
; 		! selector.append("<li><a href='#'>Acura" + Counter + "</a></li>");
; 	Next
	
	! selector.listview('refresh');
	
EndProcedure

Procedure SetWidgetText(Widget, Text.s)
	
	! var selector = $("#widget_" + Widget);
	
	Protected WidgetType.s = GetWidgetType(Widget)
	
	Select WidgetType
		Case #PB_WidgetType_Button
			! selector.text(Text);
		Case #PB_WidgetType_String
			! selector.val(Text);
	EndSelect
	
EndProcedure

Procedure.s GetWidgetText(Widget)
	
	! var selector = $("#widget_" + Widget);
	! return selector.val();
	
EndProcedure

Procedure DisableWidget(Widget, State)
	
	! var selector = $("#widget_" + Widget);	
	
	Protected WidgetType.s = GetWidgetType(Widget)
	
	Select WidgetType
		Case #PB_WidgetType_Button
			! if (State == 1 || State == true) {
			! 	selector.button("disable");
			! } else {
			! 	selector.button("enable");
			! }
		Case #PB_WidgetType_String
			! if (State == 1 || State == true) {
			! 	selector.textinput("disable");
			! } else {
			! 	selector.textinput("enable");
			! }
	EndSelect
	
EndProcedure

Procedure Notify(Message.s, Timeout = 1000)
	
	! var selector = $('<div data-role="popup" data-overlay-theme="a" data-transition="fade"><p>' + Message + '</p></div>');
	! $('body').append(selector).trigger('create');
	! selector.popup( "open" );
	! window.setTimeout( function() { selector.popup( "close" ) }, Timeout);
	
EndProcedure

Procedure MobileMessageRequester(Page, Title.s, Message.s, Flags, Callback = #Null)
	
	Protected html.s = ""
	
	Protected buttons.s = ""
	
	Select Flags
		Case #PB_MessageRequester_Ok
			buttons	 = "<a id='btnOK' href='#' class='ui-btn ui-corner-all ui-shadow ui-btn-inline'>OK</a>"
			
		Case #PB_MessageRequester_YesNo
			buttons = "<a id='btnOK'     href='#' class='ui-btn ui-corner-all ui-shadow ui-btn-inline'>OK</a>" + 
			          "<a id='btnCancel' href='#' class='ui-btn ui-corner-all ui-shadow ui-btn-inline'>Abbrechen</a>" 
			          
	EndSelect
	
	html = "<div data-role='popup' id='MsgBox' data-overlay-theme='b' data-theme='a' data-dismissible='false'>" +
	       " <div data-role='header'>" + 
	       "  <h1>" + Title + "</h1><a href='#' Data-rel='back' class='ui-btn ui-corner-all ui-shadow ui-btn-a ui-icon-delete ui-btn-icon-notext ui-btn-right'>Schliessen</a>" + 
	       " </div>" + 
	       " <div role='main' class='ui-content'>" + 
	       "  <h3 class='ui-title'>" + Message + "</h3>" + 
	       "  <div role='main' class='ui-content'>" + buttons + "</div>" + 
	       " </div>" + 
	       "</div>";
	
	! //append popup to DOM, tell jqm to enhance and initialize the popup
	! // and to remove the popup from DOM on close
	! $("#page_" + Page).append(html).find("#MsgBox").enhanceWithin().popup({
	!		afterclose: function (event, ui) {
	!			//remove from DOM on close
	!			$("#MsgBox").remove();
	!		}
	! }).popup("open");
	
	! //Add click handler for button in popup
	! $("#MsgBox").on("click", "#btnOK", function(){
	!		$("#MsgBox").popup("close");
	!		if (typeof Callback == "function") {
	!			Callback(cConstants.PB_MessageRequester_Ok);
	!   }
	! });
	
	! //Add click handler for button in popup
	! $("#MsgBox").on("click", "#btnCancel", function(){
	!		$("#MsgBox").popup("close");
	!		if (typeof Callback == "function") {
	!			Callback(cConstants.PB_MessageRequester_Cancel);
	!   }
	! });
	
EndProcedure

Procedure SpacerWidget(Widget, Space.s)
	
	! if (Widget == cConstants.PB_Any) Widget = cCommon.guid();
	! if ($("#widget_" + Widget).length > 0) FreeWidget(Widget);
	
	! var selector = $("span");
	! selector.css("margin", Space);
	! selector.attr("id", "widget_" + Widget);
	! selector.data("WidgetType", PB_WidgetType_Spacer);
	
	! currentContainer.append(selector);
	
	! return Widget;
	
	
EndProcedure

Procedure RefreshPage()
	! currentContainer.trigger( "create" );
EndProcedure

; IDE Options = PureBasic 5.41 LTS Beta 1 (Windows - x86)
; CursorPosition = 571
; FirstLine = 102
; Folding = AAAAGIA9
; EnableXP