XIncludeFile "..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

; ----------------------
; AddElement()
; ----------------------

; The simplest way to use AddElement
NewList simple.w()

AddElement(simple())    ; Creates the first new element in the list
simple() = 23

AddElement(simple())    ; Current position is the first element, so we add one to the second position
simple() = 45

ForEach simple()
	Debug simple()
Next

; 
; ; This shows how to use the return-value of AddElement
; NewList advanced.l()
; 
; If AddElement(advanced()) <> 0 ; Note: this will fail at the moment. The first element returns always 0
; 	advanced() = 12345
; Else
; 	MessageRequester("Error 1!", "Unable to allocate memory for new element"
; EndIf
; 
; ; A small structure to demonstrate the use of the pointer to the new element
; Structure Programmer
; 	Name.s
; 	Strength.b
; EndStructure
; 
; NewList Programmers.Programmer()  ; The list for storing the elements
; 
; Define *Element.Programmer
; 
; *Element = AddElement(Programmers())
; 
; If *Element <> 0
; 	*Element\Name = "Dave"
; 	*Element\Strength = 3   ; Wow, super-strong geek! ;)
; Else
; 	MessageRequester("Error 2!", "Unable to allocate memory for new element"
; EndIf
; 
; ForEach Programmers()
; 	Debug Programmers()\Name
; 	Debug Programmers()\Strength
; Next

; ----------------------
; ChangeCurrentElement()
; ----------------------

; *Old_Element = @mylist()   ; Get the address of the current element
; 
; ResetList(mylist())        ; Perform a search for all elements named
; While NextElement(mylist()); "John" and change them to "J" 
; 	If mylist()\name = "John"
; 		mylist()\name = "J"     
; 	EndIf 
; Wend     
; 
; ChangeCurrentElement(mylist(), *Old_Element) ; Restore previous current element (from before the search)

; ----------------------
; ClearList()
; ----------------------

; NewList Numbers.w()
; 
; ; A small loop to add many items to the list
; For i=1 To 100
; 	AddElement(Numbers())
; 	Numbers() = i
; Next
; 
; ; Proof that items have been added to the list
; Debug "There are "+Str(ListSize(Numbers()))+" elements in the list"
; 
; ; Clear the list and show that the list really is empty
; ClearList(Numbers())
; Debug "There are "+Str(ListSize(Numbers()))+" elements in the list"

; ----------------------
; CopyList()
; ----------------------

; NewList Friends$()
; NewList FriendsCopy$()
; 
; AddElement(Friends$())
; Friends$() = "John"
; 
; AddElement(Friends$())
; Friends$() = "Elise"
; 
; CopyList(Friends$(), FriendsCopy$())
; 
; ForEach FriendsCopy$()
; 	Debug FriendsCopy$()
; Next

; ----------------------
; DeleteElement()
; ----------------------

; NewList people.s()
; 
; AddElement(people()) : people() = "Tom"
; AddElement(people()) : people() = "Dick"
; AddElement(people()) : people() = "Harry"
; AddElement(people()) : people() = "Bob"
; 
; FirstElement(people())
; DeleteElement(people(), 1)
; Debug "First person in list is " + people()
; 
; LastElement(people())      ; Moves to "Bob"
; PreviousElement(people())	 ; Moves to "Harry"
; DeleteElement(people())		 ; And deletes him. there is an element before Harry, so it becomes the current
; Debug "Current person in list is " + people()

; ----------------------
; FirstElement()
; ----------------------


; ; An example of simple usage
; NewList Numbers.w()
; 
; AddElement(Numbers())
; Numbers() = 5
; AddElement(Numbers())
; Numbers() = 8
; 
; FirstElement(Numbers())
; Debug "First element value is "+Str(Numbers())
; 
; 
; ; An example which uses the return-value
; NewList Numbers.w()
; 
; If FirstElement(Numbers()) <> 0
; 	Debug "First element value is "+Str(Numbers())
; Else
; 	Debug "List is empty"
; EndIf
; 
; AddElement(Numbers())
; Numbers() = 5
; AddElement(Numbers())
; Numbers() = 8
; 
; If FirstElement(Numbers()) <> 0
; 	Debug "First element value is "+Str(Numbers())
; Else
; 	Debug "List is empty"
; EndIf
; 
; 
; ; An example which is only for advanced users
; NewList Numbers.w()
; 
; AddElement(Numbers())
; Numbers() = 5
; AddElement(Numbers())
; Numbers() = 8
; 
; Define *Element.Word 
; 
; *Element = FirstElement(Numbers())
; 
; If *Element
; 	Debug "First element value is "+Str(*Element\w)
; Else
; 	Debug "List is empty"
; EndIf

; ----------------------
; FreeList()
; ----------------------

; see ClearList()

; ----------------------
; InsertElement()
; ----------------------

; ; The simplest way to use InsertElement
; NewList simple.w()
; InsertElement(simple())    ; Creates the first new element in the list
; simple() = 23
; 
; InsertElement(simple())    ; Current position is the first element, so we add this element to the start of the list
; simple() = 45							 ; The old first element is now the second element in the list
; 
; ; This shows how to use the return-value of InsertElement
; NewList advanced.l()
; If InsertElement(advanced()) <> 0 ; will fail. The first element is always 0
; 	advanced() = 12345
; Else
; 	Debug "Info 1: Unable to allocate memory for new element"
; EndIf
; 
; ; A small structure to demonstrate the use of the pointer to the new element
; Structure Programmer
; 	Name.s
; 	Strength.b
; EndStructure
; 
; NewList Programmers.Programmer()  ; The list for storing the elements
; 
; Define *Element.Programmer
; 
; *Element = InsertElement(Programmers())
; 
; If *Element <> 0
; 	*Element\Name = "Dave"
; 	*Element\Strength = 3   ; Wow, super-strong geek! ;)
; Else
; 	Debug "Info 2: Unable to allocate memory for new element"
; EndIf
; 
; ForEach Programmers()
; 	Debug Programmers()\Name
; 	Debug Programmers()\Strength
; Next

; ----------------------
; LastElement()
; ----------------------

; ; An example of simple usage
; NewList Numbers.w()
; 
; AddElement(Numbers())
; Numbers() = 5
; 
; AddElement(Numbers())
; Numbers() = 8
; 
; LastElement(Numbers())
; Debug "Last element value is "+Str(Numbers())
; 
; ; An example which uses the return-value
; NewList Numbers.w()
; 
; If LastElement(Numbers()) <> 0
; 	Debug "Last element value is "+Str(Numbers())
; Else
; 	Debug "List is empty"
; EndIf
; 
; AddElement(Numbers())
; Numbers() = 5
; 
; AddElement(Numbers())
; Numbers() = 8
; 
; If LastElement(Numbers()) <> 0
; 	Debug "Last element value is "+Str(Numbers())
; Else
; 	Debug "List is empty"
; EndIf
; 
; ; An example which is only for advanced users
; NewList Numbers.w()
; 
; AddElement(Numbers())
; Numbers() = 5
; AddElement(Numbers())
; Numbers() = 8
; 
; *Element.Word = LastElement(Numbers())
; 
; If *Element
; 	Debug "Last element value is "+Str(*Element\w)
; Else
; 	Debug "List is empty"
; EndIf

; ----------------------
; ListIndex()
; ----------------------

; NewList fruit.s()
; 
; AddElement(fruit()) : fruit() = "oranges"
; AddElement(fruit()) : fruit() = "bananas"
; AddElement(fruit()) : fruit() = "apples"
; AddElement(fruit()) : fruit() = "pears"
; 
; FirstElement(fruit())
; Debug "Fruit: " + fruit() + " is now at position " + Str(ListIndex(fruit()))
; 
; NextElement(fruit())
; Debug "Fruit: " + fruit() + " is now at position " + Str(ListIndex(fruit()))
; 
; NextElement(fruit())
; Debug "Fruit: " + fruit() + " is now at position " + Str(ListIndex(fruit()))
; 
; NextElement(fruit())
; Debug "Fruit: " + fruit() + " is now at position " + Str(ListIndex(fruit()))

; ----------------------
; ListSize()
; ----------------------

; NewList countme.w()
; 
; ; Small loop to add some elements to the list.
; For i = 0 To 10
; 	AddElement(countme())
; 	countme() = i * 23
; Next
; 
; ; Show how many elements there are in the list. I hope you thought
; ; of the same value as this example ;)
; 
; Debug "There are " + Str(ListSize(countme())) + " elements in the list"

; ----------------------
; MergeLists()
; ----------------------

; NewList A.s()
; 
; AddElement(A()): A() = "a0"
; AddElement(A()): A() = "a1"
; AddElement(A()): A() = "a2"
; AddElement(A()): A() = "a3"
; 
; NewList B.s()
; AddElement(B()): B() = "b0"
; AddElement(B()): B() = "b1"
; AddElement(B()): B() = "b2"
; AddElement(B()): B() = "b3"
; 
; MergeLists(A(), B())
; 
; ForEach B()
; 	Debug B()
; Next

; ----------------------
; MoveElement()
; ----------------------

; NewList Numbers()
; 
; For k=0 To 10
; 	AddElement(Numbers())
; 	Numbers() = k
; Next
; 
; SelectElement(Numbers(), 5) 
; *Relative = @Numbers()                             ; get address of element 5
; 
; SelectElement(Numbers(), 0)
; MoveElement(Numbers(), #PB_List_After, *Relative)  ; move after element 5
; 
; SelectElement(Numbers(), 10)
; MoveElement(Numbers(), #PB_List_First)             ; move to the beginning
; 
; ; Result
; ;
; ForEach Numbers()
; 	Debug Numbers()
; Next

; ----------------------
; NextElement()
; ----------------------
; ----------------------
; PopListPosition()
; ----------------------
; ----------------------
; PreviousElement()
; ----------------------
; ----------------------
; PushListPosition()
; ----------------------
; ----------------------
; ResetList()
; ----------------------
; ----------------------
; SelectElement()
; ----------------------
; ----------------------
; SplitList()
; ----------------------
; ----------------------
; SwapElements()
; ----------------------

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 20
; EnableXP